typedef struct {
	int xs, ys;
	char **g;
	int rx;
} But;

But *newbut( int xs, int ys ) {
	int i, j;

	But *b = (But *)malloc(sizeof(But));
	b->xs = xs; b->ys = ys;
	b->g = (char **)malloc(sizeof(char *)*xs);
	for( i = 0; i < xs; i++ ) b->g[i] = (char *)malloc(sizeof(char)*ys);
	for( i = 0; i < xs; i++ ) for( j = 0; j < ys; j++ ) b->g[i][j] = ' ';
	return b;
}

void delbut( But *b ) {
	int i;

	for( i = 0; i < b->xs; i++ ) free( b->g[i] );
	free( b->g );
	free( b );
}

void printbut( But *b ) {
	int i, j, x;

	for( j = 0; j < b->ys; j++ ) {
		x = 0;
		for( i = 0; i < b->xs; i++ ) if( b->g[i][j] != ' ' ) x = i;
		for( i = 0; i <= x; i++ ) putchar( b->g[i][j] );
		putchar( '\n' );
	}
}

int calcd( But *lb, But *rb ) {
	int i, j, k, x, y, z, n;
	int d = 2;

	for( i = 1; i <= lb->ys && i <= rb->ys; i++ ) {
		y = lb->ys-i;
		for( j = lb->xs-1; j >= 0; j-- )
			if( lb->g[j][y] != ' ' ) break;
		y = rb->ys-i;
		for( k = 0; k < rb->xs; k++ )
			if( rb->g[k][y] != ' ' ) break;
		j -= lb->rx;
		k = rb->rx - k;
		if( j+k+2 > d ) d = j+k+2;
	}
	for( i = 1; i <= lb->ys && i < rb->ys; i++ ) {
		y = lb->ys-i;
		for( j = lb->xs-1; j >= 0; j-- )
			if( lb->g[j][y] != ' ' ) break;
		y = rb->ys-i-1;
		for( k = 0; k < rb->xs; k++ )
			if( rb->g[k][y] != ' ' ) break;
		j -= lb->rx;
		k = rb->rx - k;
		if( j+k+1 > d ) d = j+k+1;
	}
	for( i = 1; i < lb->ys && i <= rb->ys; i++ ) {
		y = lb->ys-i-1;
		for( j = lb->xs-1; j >= 0; j-- )
			if( lb->g[j][y] != ' ' ) break;
		y = rb->ys-i;
		for( k = 0; k < rb->xs; k++ )
			if( rb->g[k][y] != ' ' ) break;
		j -= lb->rx;
		k = rb->rx - k;
		if( j+k+1 > d ) d = j+k+1;
	}
	return d;
}

But *parse( char **tmp ) {
	int i, j, d, x1, x2, xs, ys;
	char ch = *((*tmp)++);
	But *lb, *rb, *b;

	if( **tmp != '(' ) {
		b = newbut( 1, 1 );
		b->rx = 0;
		b->g[0][0] = ch;
		return b;
	}
	(*tmp)++;
	lb = parse(tmp);
	if( **tmp == ')' ) {
		(*tmp)++;
		b = newbut( lb->xs, lb->ys+2 );
		for( i = 0; i < lb->xs; i++ ) for( j = 0; j < lb->ys; j++ )
			b->g[i][j] = lb->g[i][j];
		b->rx = lb->rx;
		b->g[b->rx][lb->ys] = '-';
		b->g[b->rx][lb->ys+1] = ch;
		delbut(lb);
		return b;
	}
	(*tmp)++;
	rb = parse(tmp);
	(*tmp)++;
	d = calcd(lb, rb);
	if( rb->rx-d > lb->rx ) {
		xs = rb->xs;
		x2 = rb->rx;
		x1 = x2-d;
	} else if( lb->xs-lb->rx-d > rb->xs-rb->rx ) {
		xs = lb->xs;
		x1 = lb->rx;
		x2 = x1+d;
	} else {
		x1 = lb->rx;
		x2 = x1+d;
		xs = lb->rx + d + rb->xs-rb->rx;
	}
	ys = ((lb->ys>rb->ys)?lb->ys:rb->ys) + 2;
	b = newbut( xs, ys );
	for( i = 0; i < lb->xs; i++ ) for( j = 0; j < lb->ys; j++ )
		if( lb->g[i][j] != ' ' ) {
			b->g[i+x1-lb->rx][ys-2-lb->ys+j] = lb->g[i][j];
		}
	for( i = 0; i < rb->xs; i++ ) for( j = 0; j < rb->ys; j++ )
		if( rb->g[i][j] != ' ' ) {
			b->g[i+x2-rb->rx][ys-2-rb->ys+j] = rb->g[i][j];
		}
	for( i = 0; i <= d; i++ ) b->g[x1+i][ys-2] = '-';
	b->rx = x1 + d/2;
	b->g[b->rx][ys-1] = ch;
	delbut(lb);
	delbut(rb);
	return b;
}


char buff[10000];

main() {
	int i, j, k, x, y, z, n, prob=1;
	char ch = ';';
	char *tmp;
	But *b;

	while( ch != '.' ) {
		x = 0;
		for(;;) {
			scanf( " %c", &ch );
			buff[x++] = ch;
			if( ch == ';' || ch == '.' ) break;
		}
		buff[x++] = 0;
		tmp = buff;
		b = parse( &tmp );
		printf( "%d:\n", prob++ );
		printbut( b );
		delbut( b );
	}
}
