/* Snake and Ladders, GC, slight changes by PR */

#include <stdio.h>
#include <math.h>

int m,n;
int follow[110];
double A[110][110];

int main() {
   int i,j,k;

   scanf("%d%d",&m,&n);

   for (i=0;i<=m*n;i++) A[i][i] = 1;

   while (2 == scanf("%d%d",&i,&j)) {
      follow[i] = j;
      A[i][j] = -1;
   }

   for (i=1;i<m*n;i++) 
     if (!follow[i]) 
       for (j = i+1; j <= i+6; j++) {
	 A[i][0] = 1;
	 if (j <= m*n)
	   A[i][j] -= 1.0/6.0;  /* add 1/6 of the flow for each die roll */
	 else
	   A[i][i] -= 1.0/6.0;  /* can't move past end of board */
       }

   /* Gaussian elimination, looking for A[1][1], value will be in A[1][0] */
   for (i = m*n; i >= 1; i--) { 
     for (k = 0; k <= m*n; k++) 
	 A[i][k] /= A[i][i];
     A[i][i] = 1;
     for (j = i-1; j >= 1; j--) 
       for (k = 0; k <= m*n; k++)
	   A[j][k] -= A[j][i] * A[i][k];
       A[j][i] = 0;
   }

   printf("%0.2f\n",A[1][0]);
   return 0;
}


