#include <stdio.h>
#include <math.h>


#define MAXN 1100


int N;
double arr[MAXN][3];
double ang1[MAXN], ang2[MAXN];
int st[MAXN];
int ist;
int used[MAXN];
double Pi;
double P;


void read_all(void);
void do_all(void);
double get_ang(int i1, int i2);
double get_len(int i1, int i2);
void mark12(int i1, int i2);
void calc_P(void);
void write_all(void);



int main(void)
{
  read_all();
  do_all();
  write_all();
  return 0;
}


void read_all(void)
{
  int i;
  double x, y, r;

  FILE *f = fopen("fence.inp", "rt");
  while (fscanf(f, "%lf %lf %lf", &x, &y, &r) == 3) {
    arr[N][0] = x;
    arr[N][1] = y;
    arr[N][2] = r;  N++;
  }
  fclose(f);
}



void do_all(void)
{
  int i, ib;
  double al, be;

  Pi = 2*acos(0);
  ib = 0;
  for (i = 1; i < N; i++) {
    if (arr[i][1]-arr[i][2] < arr[ib][1]-arr[ib][2]) {
      ib = i;
    }
  }
  st[ist++] = ib;
  for (;;) {
    be = 10;
    for (i = 0; i < N; i++) {
      if (used[i] || i == st[ist-1])  continue;
      al = get_ang(st[ist-1], i);
      if (al < be) {
        be = al;
        ib = i;
      }
    }
    st[ist++] = ib;
    used[ib] = 1;
    if (ib == st[0])  break;
  }
  ist--;
  calc_P();
}


double get_ang(int i1, int i2)
{
  double x, d;
  int r1, r2;

  r1 = arr[i1][2];
  r2 = arr[i2][2];
  d = sqrt((arr[i1][0]-arr[i2][0])*(arr[i1][0]-arr[i2][0]) + (arr[i1][1]-arr[i2][1])*(arr[i1][1]-arr[i2][1]));
  x = atan2((arr[i2][1]-arr[i1][1]), (arr[i2][0]-arr[i1][0]));
  x -= asin(1.*(r2-r1)/d);
  while (x > Pi)  x -= Pi;
  while (x < 0)  x += Pi;
  return x;
}


double get_len(int i1, int i2)
{
  double x, d;
  int r1, r2;

  r1 = arr[i1][2];
  r2 = arr[i2][2];
  d = sqrt((arr[i1][0]-arr[i2][0])*(arr[i1][0]-arr[i2][0]) + (arr[i1][1]-arr[i2][1])*(arr[i1][1]-arr[i2][1]));
  x = d*cos(asin(1.*(r2-r1)/d));
  return x;
}


void mark12(int i1, int i2)
{
  double al, d, x, y, x1, y1, x2, y2, x3, y3;
  int r1, r2;

  al = get_ang(i1, i2);
  d = get_len(i1, i2);
  x1 = -d*cos(al);
  y1 = -d*sin(al);
  x2 = arr[i2][0]+x1;
  y2 = arr[i2][1]+y1;
  x3 = x2-arr[i1][0];
  y3 = y2-arr[i1][1];
  if (fabs(x3-y3) < 1e-6 && x3 < 1e-6 && x3 > -1e-6) {
    al = atan2(y1, x1)-Pi/2;
  }
  else  al = 2*atan2(y3, x3) - atan2(arr[i2][1]-arr[i1][1], arr[i2][0]-arr[i1][0]);
  while (al > 2*Pi)  al -= 2*Pi;
  while (al < 0)  al += 2*Pi;
  ang2[i1] = ang1[i2] = al;
}


void calc_P(void)
{
  int i, j;
  double al;

  for (i = 0, j = ist-1; i < ist; j=i++) {
    P += get_len(st[i], st[j]);
    mark12(st[i], st[j]);
  }
  for (i = 0; i < ist; i++) {
    al = ang2[st[i]]-ang1[st[i]];
    while (al < 0)  al += 2*Pi;
    while (al > 2*Pi)  al -= 2*Pi;
    if (al > Pi)  al = 2*Pi-al;
    P += al*arr[st[i]][2];
  }
}



void write_all(void)
{
  FILE *f = fopen("fence.out", "wt");
  fprintf(f, "%.2lf\n", P);
  fclose(f);
}



