#include <fstream.h>
#include <stdio.h>
#include <math.h>                    

ifstream fin("fence.inp");
ofstream fout("fence.out");

typedef struct { double x,y; } CPoint;
typedef struct { double x,y,a,b; } CLach;
typedef struct { double x,y,r; } CCircle;
typedef struct { double x1,y1,x2,y2; } COts;
////
CPoint C01(CLach k1, double k2)
{
 CPoint kk1;
 double kk2=sqrt(k1.a*k1.a+k1.b*k1.b);
 kk1.x=k1.x+k2*(k1.a/kk2);
 kk1.y=k1.y+k2*(k1.b/kk2);
 return kk1;
}
////
CLach C02(CPoint k1,CPoint k2)
{
 CLach kk1;
 kk1.x=k1.x;
 kk1.y=k1.y;
 kk1.a=k2.x-k1.x;
 kk1.b=k2.y-k1.y;
 return kk1;
}
////
void C1(CPoint k1,CPoint k2,CPoint k3,double k4,CPoint &kk1,CPoint &kk2)
{
 CLach kk3=C02(k1,k2);
 double kk4;
 kk4=kk3.a; kk3.a=kk3.b; kk3.b=kk4;
 kk3.x=k3.x; kk3.y=k3.y;
 kk1=C01(kk3,k4);
 kk3=C02(k2,k1);
 kk4=kk3.a; kk3.a=kk3.b; kk3.b=kk4;
 kk3.x=k3.x; kk3.y=k3.y;
 kk2=C01(kk3,k4);
}

CPoint C11(COts k1)
{
 CPoint kk1;
 kk1.x=(k1.x1+k1.x2)/2;
 kk1.y=(k1.y1+k1.y2)/2;
 return kk1;
}

double C12(CPoint k1,CPoint k2)
{
 return sqrt((k1.x-k2.x)*(k1.x-k2.x)+(k1.y-k2.y)*(k1.y-k2.y));
}

void C2(CCircle k1,CCircle k2,CPoint &kk1,CPoint &kk2)
{
 CPoint q1,q2,q3;
 CPoint o1,o2; o1.x=k1.x; o1.y=k1.y; o2.x=k2.x; o2.y=k2.y;
 q1=C01(C02(o2,o1),k2.r);
 q2=C01(C02(o1,o2),k1.r);
 COts kk3;
 kk3.x1=q1.x; kk3.x2=q2.x; kk3.y1=q1.y; kk3.y2=q2.y;
 q3=C11(kk3);
 double raz2=C12(q1,q3),raz;
 raz=sqrt(k1.r*k1.r-raz2*raz2);
 C1(q1,q2,q3,raz,kk1,kk2);
}

void C3(CPoint k1,CCircle k2,CPoint &kk1,CPoint &kk2)
{
 CPoint kk3;
 kk3.x=k2.x;
 kk3.y=k2.y;
 double raz2=C12(kk3,k1);
 double raz=sqrt(raz2*raz2-k2.r*k2.r);
 CCircle kk4;
 kk4.x=k1.x;
 kk4.y=k1.y;
 kk4.r=raz;
 C2(k2,kk4,kk1,kk2);
}

void C4(CCircle k1,CCircle k2,CPoint &kk1,CPoint &kk2,CPoint &kk3,CPoint &kk4)
{
 CPoint kk5,kk6;
 kk5.x=k1.x; kk5.y=k1.y;
 kk6.x=k2.x; kk6.y=k2.y;
 if (k2.r-k1.r<0.001)
 {
  CLach kk7=C02(kk5,kk6);
  CLach kk8=C02(kk6,kk5);
  double pom;
  pom=kk7.a; kk7.a=kk7.b; kk7.b=pom;
  pom=kk8.a; kk8.a=kk8.b; kk8.b=pom;
  kk1=C01(kk7,k1.r);
  kk2=C01(kk7,-k1.r);
  kk3=C01(kk8,k2.r);
  kk4=C01(kk8,-k2.r);
 }
 else
 {
  double s2=C12(kk5,kk6);
  double s1=s2*k1.r/(k2.r-k1.r);
  CPoint kk7=C01(C02(kk6,kk5),s1+s2);
  C3(kk7,k1,kk1,kk3);
  C3(kk7,k2,kk2,kk4);
 }
}

int C5(CPoint k1,CPoint k2,CPoint k3)
{
 double kk1=(k1.x-k2.x)*(k1.y+k2.y)+
	    (k2.x-k3.x)*(k1.y+k2.y)+
	    (k3.x-k1.x)*(k1.y+k2.y)/2;
 if (kk1>-0.001) return 1;
 else if (kk1<-0.001) return -1; else return 0;
}

double C55(CPoint k1,CPoint k2,CPoint k3)
{
 double kk1=(k1.x-k2.x)*(k1.y+k2.y)+
	    (k2.x-k3.x)*(k1.y+k2.y)+
	    (k3.x-k1.x)*(k1.y+k2.y)/2;
 return abs(kk1);
}

double C7(CCircle k1,CPoint k2,CPoint k3)
{
 CPoint kk1;
 kk1.x=k1.x;
 kk1.y=k1.y;
 if (C5(k2,k3,kk1)==0) return k1.r*M_PI;
 else
  if (C5(k2,k3,kk1)==-1)
  {
   double ang=asin(2*C55(k3,k2,kk1)/k1.r/k1.r);
   return k1.r*(2*M_PI-ang);
  }
 else
  {
   double ang=sin(2*C55(k2,k3,kk1)/k1.r/k1.r);
   return k1.r*ang;
  }
}

CCircle a[1001];

int b[1001];
int n,nn;



void GetOgr()
{
 int ii,jj,kk;
 int izp;

 CPoint kk1,kk2,kk3,kk4,pp1,pp2,pp3,pp4,o1,o2;

 jj=1;
 for (ii=2;ii<=n;ii++)
  if (a[ii].x-a[ii].r-a[jj].x+a[jj].r<0.001) jj=ii;
 b[1]=jj;
 kk=1;
 int chan;
 do
 {
  chan=0;
  for (ii=1;ii<n;ii++)
   {
    if (b[kk]==ii) continue;
    for (jj=1;jj<=n;jj++)
    {
     if (b[kk]==jj||jj==ii) continue;
     C4(a[b[kk]],a[ii],kk1,kk2,kk3,kk4);
     o1.x=a[b[kk]].x;
     o1.y=a[b[kk]].y;
     if (C5(o1,kk1,kk2)<0) { kk1=kk3; kk2=kk4; };
     C4(a[b[kk]],a[jj],pp1,pp2,pp3,pp4);
     if (C5(o1,pp1,pp2)<0) { pp1=pp3; pp2=pp4; };

     if (C5(kk1,kk2,pp2)<0) { izp=0; break; }
    }
    if (izp)
     {
      kk++;
      b[kk]=ii;
      chan=1;
      break;
     }
   }
  if (!chan)
   {
    kk++;
    b[kk]=1;
    chan=1;
   }
 }
 while (!(b[kk]==b[1]&&chan));
 nn=kk;
}

double GetLen()
{
 double len=0;
 CPoint d[1001][2];
 CPoint o1,kk1,kk2,kk3,kk4;
 int ii;
 for (ii=1;ii<=nn-1;ii++)
  {
   C4(a[b[ii]],a[b[ii+1]],kk1,kk2,kk3,kk4);
   o1.x=a[b[ii]].x;
   o1.y=a[b[ii]].y;
   if (C5(o1,kk1,kk2)<0) { kk1=kk3; kk2=kk4; };
   d[b[ii]][1]=kk1;
   d[b[ii+1]][0]=kk2;
  }

 for (ii=1;ii<=nn-1;ii++)
  {
   len+=C7(a[b[ii]],d[ii][0],d[ii][1]);
   len+=C12(d[b[ii]][1],d[b[ii+1]][0]);
  }
 return len;
}

void main(void)
{
 double i1,i2,i3;
 n=0;
 while (!fin.eof())
  {
   n++;
   fin >> i1 >> i2 >> i3;
   a[n].x=i1;
   a[n].y=i2;
   a[n].r=i3;
  }
 n--;
 GetOgr();
 char res[30];
 sprintf(res,"%.2f",GetLen());
 fout << res;
 fout.close();
}