const
 eps = 1E-6;
 inf = 1E10;
 maxn = 1010;
 ifn = 'fence.inp';
 ofn = 'fence.out';

type
 TDot =
  record
   x, y : double;
   nm : longint;
  end;

const
 origin : TDot = (x:0; y:0);

var
 a, cv, cv1 : array [0 .. maxn] of Tdot;
 rs : array [1 .. maxn] of double;
 cl, cl1, n : longint;
 min, ans : double;
 t : text;

function dist (var a,b : Tdot) : double;
begin
 dist := sqrt (sqr (a.x-b.x) + sqr (b.y-a.y));
end;
{
function cmp (var a,b : TDot) : double;
var
 l : double;
begin
 l := a.x*b.y - a.y*b.x;
 if abs (l) < eps then
  l := dist (origin, a) - dist (origin, b);
 if abs(l) > eps then
  cmp := l
 else
  cmp := 0;
end;
}

function cmp (var a,b : Tdot) : double;
begin
 if a.y - b.y <> 0 then
  cmp := a.y - b.y
 else
  cmp := a.x - b.x;
end;

function scmp (var a,b,c : Tdot) : double;

begin
 scmp :=
  a.x * b.y + a.y * c.x + b.x * c.y
 -b.y * c.x - a.y * b.x - a.x * c.y;
end;

procedure sort (l,r : longint);
var
 i, j : longint;
 k, c : Tdot;

begin
 i := l;
 j := r;
 k := a[(i+j) div 2];

 repeat
  while cmp (a[i], k) < 0 do inc (i);
  while cmp (k, a[j]) < 0 do dec (j);
  if i <= j then
   begin
    c := a[i];
    a[i] := a[j];
    a[j] := c;
    inc (i);
    dec (j);
   end;
 until i > j;

 if i < r then sort (i, r);
 if l < j then sort (l, j);
end;

procedure addy (var j : longint);
var
 i : longint;
begin
 inc (cl);
 inc (cl1);
 cv [cl] := a[j];
 i := j+1;
 while (i <= n) and (a[j].y = a[i].y) do
  inc (i);
 j := i;
 dec (i);
 cv1 [cl1] := a[i];
end;

function eq (var a,b : Tdot) : boolean;
begin
 eq := (a.x = b.x) and (b.y = a.y);
end;

procedure getcv;
var
 i : longint;
begin
 i := 1;
 cl := -1;
 cl1 := -1;
 while i <= n do
  begin
   addy (i);
   while (cl > 1) and (scmp (cv[cl - 2], cv[cl -1], cv[cl]) > eps) do
    begin
     cv [cl - 1] := cv[cl];
     dec (cl);
    end;
   while (cl1> 1) and
         (scmp (cv1 [cl1 - 2], cv1 [cl1 -1], cv1 [cl1]) < -eps) do
    begin
     cv1 [cl1 - 1] := cv1[cl1];
     dec (cl1);
    end;

  end;

 if not eq(cv[cl], cv1 [cl1]) then
  begin
   inc (cl);
   cv[cl] := cv1[cl1];
  end;

  dec (cl1);

 for i := cl1 downto 1 do
  begin
   inc (cl);
   cv[cl] := cv1[i];
  end;

 if (cl1 >= 0) and not eq(cv[0], cv1 [0]) then
  begin
   inc (cl);
   cv[cl] := cv1[0];
  end;

 inc (cl);

end;

function acos ( cs : double ) : double;
var
 sn, ac : double;
begin
 if cs > 1 then
  cs := 1;
 if cs < 0 then acos := pi - acos (-cs)
  else
   begin
 sn := sqrt (1 - sqr(cs));
 if abs (cs) < eps then
  acos := pi /2
 else
  acos := arctan ( sn / cs);
  end;
end;

procedure calcans;
var
 i : longint;
 cs, ss: double;
 d, a, b, c : double;

begin
 i := 0;
 while i < cl do
  begin
   {dist}

   a := dist (cv[i], cv[ (i+1) mod cl]);
   b := sqr (a) - sqr ( rs[cv[i].nm] - rs [cv [(i+1) mod cl].nm] );
   d := sqrt (b);

   {arc}
   a := dist ( cv[ (cl + i - 1) mod cl] , cv[i]);
   b := dist (cv[i], cv[ (i +1) mod cl] );
   c := dist ( cv[ (cl + i - 1) mod cl] , cv[(i + 1) mod cl]);
   cs := (sqr (A) + sqr (b) - sqr (c)) / (2*a*b);
   ss := 2*pi - acos (cs);
   cs := (rs[cv[i].nm] - rs [cv [(i+1) mod cl].nm]) / b;
   ss := ss - acos (cs);
   cs := (rs[cv[i].nm] - rs [cv [(cl+i-1) mod cl].nm]) / a;
   ss := ss - acos (cs);

   if ss > - eps then
    begin
     ans := ans + d + ss * rs [cv[i].nm];
     inc (i);
    end
   else
    begin
     move (cv[i+1], cv[i], (cl - i) * sizeof (Tdot));
     dec (cl);
    end;
  end;
end;

procedure input;
begin
 assign (t, ifn);
 reset (t);
 while not seekeof (t) do
  begin
   inc (n);
   readln (t, a[n].x, a[n].y, rs[n]);
   if a[n].x < min then
    min := a[n].x;
   if a[n].y < min then
    min := a[n].y;
   a[n].nm := n;
  end;
 close (t);
end;

procedure output;
begin
 assign (t, ofn);
 rewrite (t);
 writeln (t, ans:0:2);
 close (t);
end;

procedure initvs;
var
 i : longint;
begin
 for i := 1 to n do
 with a[i] do
  begin
   x := x - min +10;
   y := y - min +10;
  end;
end;

procedure if2;
begin
 ans := 2 * dist(a[1], a[2]) + pi * rs[1] + pi *rs[2];
end;

begin
 input;
   initvs;
   sort (1, N);
   getcv;
   calcans;
 output;
{ a[1].x := -1;
 a[1].y := -1;
 a[2].x := 0;
 a[2].y := 2;
 writeln (scmp (origin, a[1], a[2]));}

end.