/*****************************************************************************
   AUTHOR: mukov
   PROGRAM: build
   INPUT(file): build.inp
   OUTPUT(file): build.out
*****************************************************************************/
/* INCLUDE ******************************************************************/
   #include <string>
   #include <fstream>
   #include <stdlib.h>

/* CONSTANTS ****************************************************************/
   const string S_FIN = "build.inp";
   const string S_FOUT = "build.out";

   const int MAX = 15;

/* CLASSES ******************************************************************/
/* GLOBALS ******************************************************************/
   ifstream fin(S_FIN.c_str());
   ofstream fout(S_FOUT.c_str());

   int m;
   int n;
   int maxmn;
   int d[MAX][MAX];

/* FUNCTIONS ****************************************************************/
/****************************************************************************/
   void done()
   {  fout << d[m][n] << endl;

      fin.close();
      fout.close();
      exit(0);
   }
/****************************************************************************/
   void init()
   {  fin >> m >> n;
      if (m > n) maxmn = m; else maxmn = n;
   }
/****************************************************************************/
   void run()
   {  int i;
      for (i = 0; i <= maxmn; i++)
      {  d[0][i] = 1;
         d[i][0] = 1;
      }

      for (i = 2; i <= maxmn; i += 2)
      {  d[1][i] = 1;
         d[1][i - 1] = 0;
         d[i][1] = 1;
         d[i - 1][1] = 0;
      }


      int y;
      for (y = 2; y <= maxmn; y++)
      {  int x;
         for (x = y; x <= maxmn; x++)
         {  d[x][y] = (d[x - 2][y] * d[2][y - 1]) + (d[x - 1][y] * d[1][y - 2]);
            d[y][x] = d[x][y];
         }
      }
   }
/****************************************************************************/
   int main()
   {  init();
      run();
      done();

      return 0;
   }
/****************************************************************************/


