/*****************************************************************************
   AUTHOR: mukov
   PROGRAM: routes
   INPUT(file): routes.inp
   OUTPUT(file): routes.out
*****************************************************************************/
/* INCLUDE ******************************************************************/
   #include <string>
   #include <fstream>
   #include <stdlib.h>

/* CONSTANTS ****************************************************************/
   const string S_FIN = "routes.inp";
   const string S_FOUT = "routes.out";

   const int MAX_V = 180;

/* CLASSES ******************************************************************/
/* GLOBALS ******************************************************************/
   ifstream fin(S_FIN.c_str());
   ofstream fout(S_FOUT.c_str());

   int c_v;
   int v[MAX_V];
   int c_buf = 0;
   int buf[MAX_V];
   int e[MAX_V][MAX_V];

/* FUNCTIONS ****************************************************************/
/****************************************************************************/
   void done()
   {
      fin.close();
      fout.close();
      exit(0);
   }
/****************************************************************************/
   void init()
   {  memset(e, 0, sizeof(e[0][0]) * MAX_V * MAX_V);

      fin >> c_v;
      int i;
      for (i = 1; i <= c_v; i++)
      {  int cc;
         fin >> cc;
         int j;
         for (j = 1; j <= cc; j++)
         {  int to;
            fin >> to;
            e[i][to] = 1;
         }
      }
   }
/****************************************************************************/
   void destroy()
   {  int i = c_buf;
      do
      {  i--;
         e[buf[i]][buf[i + 1]] = 0;
         e[buf[i + 1]][buf[i]] = 0;
      } while (buf[i] != buf[c_buf]);
   }
/****************************************************************************/
   void rec(int vt)
   {  c_buf++;
      buf[c_buf] = vt;

      if (v[vt] != 0)
      {  destroy();
         c_buf--;
         return;
      }

      v[vt] = c_buf;

      int i;
      for (i = 1; i <= c_v; i++)
         if ((e[vt][i] != 0) && (i != buf[c_buf - 1]) && (i != vt))
            rec(i);

      //v[vt] = 0;
      c_buf--;
   }
/****************************************************************************/
   void run()
   {
      rec(1);
      int i;
      for (i = 1; i < c_v; i++)
      {  int j;
         for (j = i + 1; j <= c_v; j++)
            if (e[i][j] != 0)
               fout << i << ' '<< j << endl;
      }
   }
/****************************************************************************/
   int main()
   {  init();
      run();
      done();

      return 0;
   }
/****************************************************************************/


