Const
        InFile = 'fence.inp';
        OutFile = 'fence.out';

        EPS = 0.000001;
        MAXN = 1050;

Type
        TPoint = record
            x,y : real;
        end;

        TOkr = record
           o : TPoint;
           r : real;
        end;

        TSpecialPoint = record
           x,y   : real;
           Id    : integer;
        end;

Var
        FIn,FOut : text;
        steck    : array [1..2*MAXN] of TSpecialPoint;
        count    : integer;
        obv      : array [1..MAXN] of integer;
        obvOkr   : array [1..MAXN,1..2] of TPoint;
        obvN     : integer;
        okr      : array [1..MAXN] of TOkr;
        ps       : array [1..4*MAXN] of TSpecialPoint;
        n        : integer;
        WALL     : real;

procedure loadPs(i : integer);
var
   j : integer;
begin
    j := (i-1) * 4;
    ps[j+1].x := okr[i].o.x - okr[i].r;
    ps[j+1].y := okr[i].o.y;
    ps[j+1].id := i;
    ps[j+2].x := okr[i].o.x + okr[i].r;
    ps[j+2].y := okr[i].o.y;
    ps[j+2].id := i;
    ps[j+3].x := okr[i].o.x;
    ps[j+3].y := okr[i].o.y + okr[i].r;
    ps[j+3].id := i;
    ps[j+4].x := okr[i].o.x;
    ps[j+4].y := okr[i].o.y - okr[i].r;
    ps[j+4].id := i;
end;

procedure swap(var a,b : TSpecialPoint);
var
   temp : TSpecialPoint;
begin
   temp := a;
   a := b;
   b := temp;
end;

procedure QSort(i,j : Integer);
var
   n : TSpecialPoint;
   k,l : integer;
begin
   n := ps[ (i+j) div 2];
   k := i;
   l := j;
   while (k <= l ) do begin
       while (ps[k].x < n.x) or ( (ps[k].x = n.x) and (ps[k].y < n.y)) do
              inc(k);
       while (ps[l].x > n.x) or ( (ps[l].x = n.x) and (ps[l].y > n.y)) do
              dec(l);
       if (k <= l) then begin
          swap(ps[k],ps[l]);
          inc(k); dec(l);
       end;
   end;
   if k < j then
          QSort(k,j);
   if l > i then
          QSort(i,l);
end;

function SS(a,b,c : TSpecialPoint) : integer;
var
   s : real;
begin
   s := (a.x - b.x)*(a.y+b.y) + (b.x-c.x)*(b.y+c.y) + (c.x-a.x)*(c.y+a.y);
   if s > EPS then
       SS := 1
   else
       if s < -EPS then
           SS := -1
       else
           SS := 0;
end;

procedure FindObv;
var
   i : integer;
   t : integer;

begin
   count := 2;
   steck[1] := ps[1]; steck[2] := ps[2];

   for i:=3 to N*4 do begin
      while (count > 1) and (SS(steck[count-1],steck[count],ps[i]) <= 0) do
                dec(Count);
      inc(count);
      steck[count] := ps[i];
   end;
   t := 1;
   obv[t] := steck[1].id;
   for i := 2 to count-1 do
      if steck[i].id <> obv[t] then begin
         inc(t);
         obv[t] := steck[i].id;
      end;
   count := 2;
   steck[1] := ps[n*4]; steck[2] := ps[n*4-1];
   for i := 4*n - 2 downto 1 do begin
      while (count > 1) and (SS(steck[count-1],steck[count],ps[i]) <= 0) do
                dec(Count);
      inc(count);
      steck[count] := ps[i];
   end;
   for i:=1 to count do
      if steck[i].id <> obv[t] then begin
          inc(t);
          obv[t] := steck[i].id;
      end;
   obvN := t;
end;

procedure rotate(P : TPoint; Var Res : TPoint; alpha : Real);
begin
    res.x := p.x * cos(alpha) - p.y * sin(alpha);
    res.y := p.x * sin(alpha) + p.y * cos(alpha);
end;

procedure SpecialRotate(P : TPoint; Var Res : TPoint; Cen : TPoint; alpha : Real);
begin
    P.x := P.x - cen.X;
    P.y := P.y - cen.Y;
    rotate(P,Res,alpha);
    res.x := Res.x + cen.X;
    res.y := res.Y + cen.Y;
end;

function dist2(p1,p2 : TPoint) : Real;
begin
   dist2 := sqr(p1.x- p2.x) + sqr(p1.y - p2.y);
end;

function dist(p1,p2 : TPoint) : Real;
begin
   dist := sqrt( sqr(P1.x-p2.x) + sqr(p1.y - p2.y));
end;

procedure findDop(k1,k2 : TOkr;i,j : integer);
var
      alpha,beta : real;
      k          : real;

begin
      if k1.r > k2.r then

          alpha := PI/2 - arctan( (K1.r - k2.r ) /
                   SQRT( dist2(k1.o,k2.o) - sqr( k1.r - k2.r)))

      else
          if abs(k1.r-k2.r) < EPS then
              alpha := PI/2
          else
              alpha := PI/2 + arctan( (K2.r - k1.r ) /
                   SQRT( dist2(k1.o,k2.o) - sqr( k1.r - k2.r)));


      beta := PI - alpha;

      SpecialRotate(k2.o,obvOkr[i,2],k1.o,-alpha);
      k := k1.r / dist(k1.o,k2.o);
      obvOkr[i,2].x := (obvOkr[i,2].x - k1.o.x) * k + k1.o.x;
      obvOkr[i,2].y := (obvOkr[i,2].y - k1.o.y) * k + k1.o.y;

      SpecialRotate(K1.o,obvOkr[j,1],k2.o,beta);
      k := k2.r / dist(k1.o,k2.o);
      obvOkr[j,1].x := (obvOkr[j,1].x - k2.o.x) * k + k2.o.x;
      obvOkr[j,1].y := (obvOkr[j,1].y - k2.o.y) * k + k2.o.y;

      wall := wall + dist( obvOkr[i,2], obvOkr[j,1]);
end;

function angle(id,t : integer) : real;
var
        k : TOkr;
        cosA,sinA : real;
        Al1       : real;

begin
    k := okr[id];

    cosa := obvOkr[id,t].x - K.O.x;
    sina := obvOkr[id,t].y - K.O.y;

    if abs(cosa) < eps then begin
       if obvOkr[id,t].y > K.O.y then
           al1 := PI/2
       else
           al1 := -PI/2;
    end
    else begin
       al1 := arctan(sina/cosa);
       if cosa < 0 then
          al1 := al1 + PI;
    end;

    while (al1 < 0 ) do al1 := al1 + 2*PI;
    while (al1 > 2*PI) do al1 := al1 - 2*PI;
    angle := al1;
end;

function raz(id : integer) : real;
var
   al1 , al2 : Real;
begin
   al1 := angle(id,1);
   al2 := angle(id,2);
   al1 := al2 - al1;
   while al1 < 0 do
      al1 := al1 + 2*pi;
   raz := al1 * okr[id].r;
end;

procedure solve;
var
        I : Integer;
begin
    if n = 1 then
       WALL := 2*pi * okr[1].r
    else begin
        QSort(1,n*4);
        FindObv;

        WALL := 0;

        for i := 1 to obvN - 1 do
            findDop(okr[obv[i]],okr[ obv[i+1] ],obv[i],obv[i+1]);

        for i := 1 to obvN-1 do
            wall := wall + raz(obv[i]);

    end;
    writeln(FOut,WALL:0:2);
end;

Begin
    assign(FIn,InFile); reset(FIn);
    assign(FOut,OutFile); rewrite(FOut);
    n := 0;
    while not eof(FIn) do begin
        inc(n);
        readln(FIn,okr[n].o.x,okr[n].o.y,okr[n].r);
        loadPs(n);
    end;
    close(FIn);
    solve;
    close(FOut);
End.