/*
NAME: Ivan Anev
SCHOOL: SMG
ID: A5
PROG: travel
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <limits.h>
#include <time.h>

#define MAXN 256

typedef struct Point TPoint;
struct Point {
	int x, y;
};

typedef struct Vex TVex;
typedef struct Edge TEdge;

struct Vex {
	int v, b;
	TEdge *edges;
};

struct Edge {
	int v, w;
	TEdge *next;
};

int n;
TPoint pt[MAXN];
TVex vs[MAXN];
clock_t s;

int bp;
int path[MAXN];

void readf(void);
void solve(void);
void writef(void);

int main(void) {
	readf();
	solve();
	writef();

	return 0;
}

void readf(void) {
//	FILE *fin;
	int i;

//	fin = fopen("travel.in", "r");
//	fscanf(fin, "%d", &n);
//	for (i = 0; i < n; ++i)
//		fscanf(fin, "%d %d\n", &pt[i].x, &pt[i].y);
//	fclose(fin);


	scanf("%d", &n);
	for (i = 0; i < n; ++i)
		scanf("%d%d", &pt[i].x, &pt[i].y);
}

void solve(void) {
	int i, j;

	void add_edge(int a, int b);
	int dfs(int v, int cp, int len);

	s = clock();

	for (i = 0; i < n; ++i)
		for (j = 0; j < n; ++j)
			if (i != j)
				add_edge(i, j);

	bp = INT_MAX;
	dfs(0, 0, 1);
}

void writef(void) {
	int i;

	printf("%d", path[0]+1);
	for (i = 1; i < n; ++i)
		printf(" %d", path[i]+1);
	printf("\n");
}

void add_edge(int a, int b) {
	TEdge *e, **se;

	e = (TEdge*)malloc(sizeof(TEdge));
	e->v = b;
	e->w = abs(pt[a].x - pt[b].x) + abs(pt[a].y - pt[b].y);
	for (se = &vs[a].edges; *se && (*se)->w < e->w; se = &(*se)->next)
		;
	e->next = *se;
	*se = e;
}

int dfs(int v, int cp, int len) {
	TEdge *e;
	int i, u;
	clock_t c;

	if (cp < bp) {
		vs[v].v = 1;
		for (e = vs[v].edges; e; e = e->next)
			if (e->v == 0 && len == n) {
				if (cp + e->w < bp) {
					bp = cp + e->w;
					u = v;
					for (i = n-1; i >= 0; --i) {
						path[i] = u;
						u = vs[u].b;
					}
				}
			}
			else if (vs[e->v].v == 0) {
				c = clock();
				if ((c - s) / 1000.0 > 4.9)
					return 1;
				vs[e->v].b = v;
				if (dfs(e->v, cp + e->w, len+1))
					return 1;
			}
		vs[v].v = 0;
	}

	return 0;
}
