#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#define IN "travel.inp"
#define MAX_N 250
#define MAX_VALUE 100000

struct TNode{
 int x,y;
 int num;
};
typedef struct TNode TNode;

FILE *fp;
int   dd[MAX_N][MAX_N];
int   result[MAX_N];
int   pred[MAX_N];
int   used[MAX_N];
TNode mas[MAX_N];

int n;
int beg,vend;

void input();
void solve();
void output();
void FillDD();
void prepareout();

int main(void){

 input();
 FillDD();
 solve();
 prepareout();
 output();

 return 0;
}

void input(){
 int i;

// fp=fopen(IN,"r");
  scanf("%d", &n);
  for(i=0; i<n; i++){
   scanf("%d %d", &mas[i].x, &mas[i].y);
   mas[i].num=i+1;
  }
// fclose(fp);

 for(i=0; i<=n; i++)
  used[i]=0;
}

void FillDD(){
 int i,j;

 for(i=0; i<n; i++)
  for(j=0; j<n; j++)
   if(i!=j) dd[i][j]=abs(mas[i].x-mas[j].x)+abs(mas[i].y-mas[j].y);
}

void solve(){
 int i,j,count=0;
 int el_x,el_y,el1,el2;
 long int min1,min2;

 min1=MAX_VALUE;
 for(i=0; i<n; i++)
  for(j=0; j<n; j++)
   if(i!=j&&dd[i][j]<min1) {el_x=i; el_y=j; min1=dd[i][j];}

 beg=el_x; vend=el_y;
 pred[vend]=beg;
 count=2; used[beg]=1; used[vend]=1;
 while(count<n){
  min1=MAX_VALUE; min2=MAX_VALUE;
  for(i=0; i<n; i++)
   if(i!=beg&&!used[i]&&min1>dd[i][beg]) {min1=dd[i][beg]; el1=i;}

  for(i=0; i<n; i++)
   if(i!=vend&&!used[i]&&min2>dd[i][vend]) {min2=dd[i][vend]; el2=i;}

  if(min1<min2){
   pred[beg]=el1;
   beg=el1;
   used[el1]=1;
  }
  else{
   pred[el2]=vend;
   vend=el2;
   used[el2]=1;
  }
  count++;
 }

 pred[beg]=-1;
}

void output(){
 int i,start;

 for(i=0; i<n; i++)
  if(result[i]==1) {start=i; break;}

 if(start==0){
  for(i=start; i<n-1; i++)
   printf("%d ", result[i]);
  printf("%d\n", result[n-1]);
 }
 else{
  for(i=start; i<n; i++)
   printf("%d ", result[i]);
  for(i=0; i<start-1; i++)
   printf("%d ", result[i]);
  printf("%d\n", result[start-1]);
 }
}

void prepareout(){
 int x,tmp;

 tmp=n-1; x=vend;
 while(x!=-1){
  result[tmp--]=x+1;
  x=pred[x];
 }
}

