#include <stdio.h>
#include <string.h>
#include <algorithm>

#define MAX 300
#define INF 100000000

int d[MAX][MAX];
int x[MAX],y[MAX];
int n;
int g1[MAX]; // greedy1;
int b[MAX];  // brutal;
int r[MAX]; // random;
int p[MAX];

void init () {
int i,j;
  scanf("%d",&n);
  for (i=1;i<=n;i++) {
    scanf("%d%d",&x[i],&y[i]);
    for (j=1;j<i;j++)
      d[i][j] = d[j][i] = abs(x[i]-x[j])+abs(y[i]-y[j]);
  }
}

int greedy1() {
int i,j,used[MAX];
int dst=0;
int cur = 1;
int best;
  g1[1] = 1;
  memset(used,0,sizeof(used));
  used[1] = 1;
  for (i=2;i<=n;i++) {
    int bdist = INF;
    for (j=1;j<=n;j++)
      if ( (i!=j) && (!used[j]) && (d[cur][j]<bdist) ) {
        bdist = d[cur][j];
        best = j;
      }
    dst+=bdist;
    cur = best;
    used[cur] = 1;
    g1[i] = cur;
  }
  dst+=d[1][g1[n]];
//  printf("Greedy alg: %d\n",dst);
  return dst;
}

int fact(int n) {
  if (n==1) return 1; else return n*fact(n-1);
}

int brutal() {
int p[MAX],dst,tmp;
int best = INF;
int i,j;

  for (i=0;i<n;i++) p[i] = i+1;
  dst = 0;
  for (j=0;j<(n-1);j++) dst+=d[p[j]][p[j+1]];
  dst+=d[p[n-1]][p[0]];
  if (dst<best) {
    for(j=0;j<n;j++) b[j+1]=p[j];
    best = dst;
  }
  tmp = fact(n);
  for (i=1;i<=tmp;i++) {
    next_permutation(p,p+n);
    dst = 0;
    for (j=0;j<(n-1);j++) dst+=d[p[j]][p[j+1]];
    dst+=d[p[n-1]][p[0]];
    if (dst<best) {
      for(j=0;j<n;j++) b[j+1]=p[j];
      best = dst;
    }
  }
//  printf("Brtual force : %d\n",best);
  return best;
}

int randoms() {
int i,j;
int used[MAX];
int cur = 1;
int dst=0;
int v;
  for (i=1;i<=n;i++) used[i] = 0;
  used[1] = 1;
  p[1] = 1;
  for (i=2;i<=n;i++) {
    int zz;
    if (n==i) zz=0; else zz= random()%(n-i);
    v = 1;
    for (j=0;j<=zz;j++) {
      if (used[v]) j--;
      v++;
    }
    v--;
    used[v] = 1;
    dst+=d[cur][v];
    cur = v;
    p[i] = v;
  }
  dst+=d[1][p[n]];
//  printf("Random choice: %d\n",dst);
  return dst;
}

int randomcall() {
int i,j;
int best = INF;
int rss;
  for (i=1;i<=10000;i++) {
    srandom(i);
    rss = randoms();
    if (rss<best) {
       for (j=1;j<=n;j++) r[j] = p[j];
       best = rss;
    }
  }
//  printf("Random all: %d\n",best);
  return best;
}

void solve() {
int minimum = INF;
int i;
int g1s,bs,rs;

  if (n<=10) {
    bs = brutal();
    minimum = bs;
  } else {
    g1s = greedy1();
    if (g1s<minimum) {
      for (i=1;i<=n;i++) b[i] = g1[i];
      minimum=g1s;
    }
    rs = randomcall();
    if (rs<minimum) {
      for (i=1;i<=n;i++) b[i] = r[i];
    }
  }
  for (i=1;i<=n;i++) printf("%d%c",b[i],(i==n)?'\n':' ');
}

int main () {
  init();
  solve();
  return 0;
}
