#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXN 128
#define MAXK 64
#define INF 2000000

int grid[MAXN][MAXN];
int sx, sy;

int x, y;
int mx[MAXK], my[MAXK];
int mc;

int dist[MAXN*MAXN];
int heap[MAXN*MAXN];
int pos[MAXN*MAXN];
int safe[MAXN*MAXN];

void shift_up(int p) {
	int c, t;

	c = p;
	while (c > 1) {
		if (dist[heap[c]] < dist[heap[c/2]]) {
			t = heap[c/2];
			heap[c/2] = heap[c];
			heap[c] = t;
			pos[heap[c]] = c;
			c = c/2;
		} else
			break;
	}
	pos[heap[c]] = c;
}

void push(int d) {
	int c;

	c = heap[0];
	heap[0]++;
	heap[c] = d;
	pos[d] = c;
	shift_up(c);
}

void update(int t) {
	if (pos[t] > 0)
		shift_up(pos[t]);
	else
		push(t);
}

int pop() {
	int rv;
	int c;
	int t;

	rv = heap[1];
	pos[rv] = -1;
	heap[0]--;
	heap[1] = heap[heap[0]];
	c = 1;

	while (c*2 < heap[0]) {
		if ((c*2+1 < heap[0]) &&
		    (dist[heap[c*2]] < dist[heap[c*2 + 1]])) {
			if (heap[c] > heap[c*2]) {
				t = heap[c];
				heap[c] = heap[c*2];
				heap[c*2] = t;
				pos[heap[c]] = c;
				c = c*2;
			}
		} else if (heap[c] > heap[c*2 + 1]) {
				t = heap[c];
				heap[c] = heap[c*2 + 1];
				heap[c*2 + 1] = t;
				pos[heap[c]] = c;
				c = c*2 + 1;
		} else
			break;
	}
	pos[heap[c]] = c;

	return rv;
}

void read_data() {
	int i, j;
        char tmp;
	
	scanf("%d%d%d\n", &sx, &sy, &mc);
	for (i = 0; i < sx; i++) {
		for (j = 0; j < sy; j++) {
			scanf("%c", &tmp);
			if (tmp == 'X')
				grid[i][j] = -1;
			else
				grid[i][j] = tmp - '0';
		}
		scanf("%c", &tmp); // read newline
	}
	scanf("%d%d", &x, &y);
	x--; y--;
	for (i = 0; i < mc; i++) {
		scanf("%d%d", &mx[i], &my[i]);
		mx[i]--; my[i]--;
	}
}

void fill(int m) {
	int p;
	int t1, t2, tx, ty;
	
	p = mx[m]*MAXN + my[m];
	dist[p] = 0;
	push(p);

	while (heap[0] > 1) {
		t1 = pop();
		ty = t1%MAXN; tx = t1/MAXN;

		t2 = (tx-1)*MAXN + ty;
		if ((tx-1 > 0) && (grid[tx-1][ty] > 0) &&
		    (dist[t2] > dist[t1] + grid[tx][ty])) {
			dist[t2] = dist[t1] + grid[tx][ty];
			update(t2);
		}
		t2 = (tx-2)*MAXN + ty;
		if ((tx-2 > 0) && (grid[tx-2][ty] > 0) &&
		    (dist[t2] > dist[t1] + grid[tx][ty])) {
			dist[t2] = dist[t1] + grid[tx][ty];
			update(t2);
		}
		t2 = (tx+1)*MAXN + ty;
		if ((tx+1 < sx) && (grid[tx+1][ty] > 0) &&
		    (dist[t2] > dist[t1] + grid[tx][ty])) {
			dist[t2] = dist[t1] + grid[tx][ty];
			update(t2);
		}
		t2 = (tx+2)*MAXN + ty;
		if ((tx+2 < sx) && (grid[tx+2][ty] > 0) &&
		    (dist[t2] > dist[t1] + grid[tx][ty])) {
			dist[t2] = dist[t1] + grid[tx][ty];
			update(t2);
		}
		t2 = (tx-1)*MAXN + ty+1;
		if ((tx-1 > 0) && (grid[tx-1][ty+1] > 0) &&
		    (dist[t2] > dist[t1] + grid[tx][ty])) {
			dist[t2] = dist[t1] + grid[tx][ty];
			update(t2);
		}
		t2 = (tx+1)*MAXN + ty+1;
		if ((tx+1 < sx) && (grid[tx+1][ty+1] > 0) &&
		    (dist[t2] > dist[t1] + grid[tx][ty])) {
			dist[t2] = dist[t1] + grid[tx][ty];
			update(t2);
		}
	}
}

void find() {
	int p;
	int t1, t2, tx, ty;
	
	p = x*MAXN + y;
	dist[p] = 0;
	push(p);

	while (heap[0] > 1) {
		t1 = pop();
		ty = t1%MAXN; tx = t1/MAXN;

		t2 = (tx-1)*MAXN + ty;
		if ((tx-1 > 0) && (grid[tx-1][ty] > 0) &&
		    (dist[t2] > dist[t1] + grid[tx][ty])) {
			dist[t2] = dist[t1] + grid[tx][ty];
			if (dist[t2] < safe[t2])
				update(t2);
		}
		t2 = (tx-2)*MAXN + ty;
		if ((tx-2 > 0) && (grid[tx-2][ty] > 0) &&
		    (dist[t2] > dist[t1] + grid[tx][ty])) {
			dist[t2] = dist[t1] + grid[tx][ty];
			if (dist[t2] < safe[t2])
				update(t2);
		}
		t2 = (tx+1)*MAXN + ty;
		if ((tx+1 < sx) && (grid[tx+1][ty] > 0) &&
		    (dist[t2] > dist[t1] + grid[tx][ty])) {
			dist[t2] = dist[t1] + grid[tx][ty];
			if (dist[t2] < safe[t2])
				update(t2);
		}
		t2 = (tx+2)*MAXN + ty;
		if ((tx+2 < sx) && (grid[tx+2][ty] > 0) &&
		    (dist[t2] > dist[t1] + grid[tx][ty])) {
			dist[t2] = dist[t1] + grid[tx][ty];
			if (dist[t2] < safe[t2])
				update(t2);
		}
		t2 = (tx-1)*MAXN + ty+1;
		if ((tx-1 > 0) && (grid[tx-1][ty+1] > 0) &&
		    (dist[t2] > dist[t1] + grid[tx][ty])) {
			dist[t2] = dist[t1] + grid[tx][ty];
			if (dist[t2] < safe[t2])
				update(t2);
		}
		t2 = (tx+1)*MAXN + ty+1;
		if ((tx+1 < sx) && (grid[tx+1][ty+1] > 0) &&
		    (dist[t2] > dist[t1] + grid[tx][ty])) {
			dist[t2] = dist[t1] + grid[tx][ty];
			if (dist[t2] < safe[t2])
				update(t2);
		}
	}

}

void solve() {
	int best;
	int i;

	heap[0] = 1;
	for (i = 0; i < MAXN*MAXN; i++)
		dist[i] = INF;
		
	for (i = 0; i < mc; i++)
		fill(i);

	memcpy(safe, dist, MAXN*MAXN*sizeof(int));
	
	for (i = 0; i < MAXN*MAXN; i++)
		dist[i] = INF;
	find();
	best = 0;
	for (i = 0; i < MAXN*MAXN; i++)
		if ((safe[i] != INF) && (dist[i] != INF) &&
		    (safe[i] > best) && (dist[i] <= safe[i]))
			best = safe[i];

	printf("%d\n", best);
}

int main() {
	read_data();
	solve();
	return 0;
}
