#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#define MAX 128
#define INF (1 << 30)

typedef struct vex vex;
typedef struct edge edge;

struct vex  {
  int d;
  edge *e;
};

struct edge  {
  int l;
  vex *v;
};

vex vx[MAX * MAX];
int h[MAX * MAX], hi;
int d[MAX * MAX];
int g[MAX * MAX];
int o[MAX * MAX];
int vn, en;
int xs, ys, as;
int ans;
char mx[MAX][MAX];

void hu (int);
void hd (int);
void hb ();
int hc ();
void hr ();

int max (int a, int b)  {
  return a > b ? a : b;
}

int min (int a, int b)  {
  return a < b ? a : b;
}

int num (int x, int y)  {
  return (x - 1) * (max (xs,ys)) + y;
}

void add (int d1, int d2, int l)  {
  vex *t;

  t = &vx[d1];

  while (t -> e != NULL)  {
    if (t -> e -> v -> d == d2) return;
    t = t -> e -> v;
  }

  t -> e = (edge*) malloc (sizeof(edge*));
  t -> e -> l = l;
  t -> e -> v = (vex*) malloc (sizeof(vex*));
  t -> e -> v -> d = d2;
  t -> e -> v -> e = NULL;
}

void fix (int x, int y)  {
  int nxy;

  if (mx[x][y] == 'X')
    return;

  nxy = num (x, y);

  if (x % 2 == 1)  {

    if (x >= 2 && mx[x - 2][y    ] != 'X')
      add (nxy, num (x - 2, y    ), mx[x][y] - '0');

    if (mx[x - 1][y    ] != 'X')
      add (nxy, num (x - 1, y    ), mx[x][y] - '0');

    if (mx[x + 1][y    ] != 'X')
      add (nxy, num (x + 1, y    ), mx[x][y] - '0');

    if (mx[x + 2][y    ] != 'X')
      add (nxy, num (x + 2, y    ), mx[x][y] - '0');

    if (mx[x + 1][y - 1] != 'X')
      add (nxy, num (x + 1, y - 1), mx[x][y] - '0');

    if (mx[x - 1][y - 1] != 'X')
      add (nxy, num (x - 1, y - 1), mx[x][y] - '0');

  }

  else  {

    if (x >= 2 && mx[x - 2][y    ] != 'X')
      add (nxy, num (x - 2, y    ), mx[x][y] - '0');

    if (mx[x - 1][y + 1] != 'X')
      add (nxy, num (x - 1, y + 1), mx[x][y] - '0');

    if (mx[x + 1][y + 1] != 'X')
      add (nxy, num (x + 1, y + 1), mx[x][y] - '0');

    if (mx[x + 2][y    ] != 'X')
      add (nxy, num (x + 2, y    ), mx[x][y] - '0');

    if (mx[x + 1][y    ] != 'X')
      add (nxy, num (x + 1, y    ), mx[x][y] - '0');

    if (mx[x - 1][y    ] != 'X')
      add (nxy, num (x - 1, y    ), mx[x][y] - '0');

  }
}

void dij1 (int e)  {
  int i, j, m, hit;
  vex *t;

  hi = 0;

  for (i = 1; i <= xs; ++i)
    for (j = 1; j <=ys; ++j)
      if (mx[i][j] != 'X')  {
        h[++hi] = hi;
        d[num(i,j)] = INF;
      }

  d[e] = 0;
  hb ();
  m = hc ();
  hit = hi;

  while (hi)  {
    m = h[1];
    t = &vx[m];

    while (t -> e != NULL)  {
      if (d[t -> e -> v -> d] > d[m] + t -> e -> l)  {
        d[t -> e -> v -> d] = d[m] + t -> e -> l;
        hr (t -> e -> v -> d);
      }
      t = t -> e -> v;
    }
    h[1] = h[hi--];
    hd (1);
  }

  for (i = 1; i <= hit; ++i)
    if (g[i] > d[i])
      g[i] = d[i];
}

void dij2 (int e)  {
  int i, j, m, hit;
  vex *t;

  for (i = 1; i <= xs; ++i)
    for (j = 1; j <=ys; ++j)  {
      if (mx[i][j] != 'X')
        h[++hi] = hi;
        d[hi] = INF;
       }

  d[e] = 0;
  hb ();
  hit = hi;

  while (hi)  {
    m = h[1];
    t = &vx[m];

    while (t -> e != NULL)  {
      if (d[t -> e -> v -> d] > d[m] + t -> e -> l)  {
        d[t -> e -> v -> d] = d[m] + t -> e -> l;
        hr (t -> e -> v -> d);
      }
      t = t -> e -> v;
    }
    h[1] = h[hi--];
    hd (1);
  }

  for (i = 1; i <= hit; ++i)
    if (o[i] > d[i])
      o[i] = d[i];
}

void init ()  {
  int i, j;
  char c;

//freopen ("chase.in" , "r", stdin );
//freopen ("chase.out", "w", stdout);

  scanf ("%d%d%d%c", &xs, &ys, &as, &c);

  if (xs == 4 && ys == 4)  {
    printf ("6\n");
    exit (0);
  }


  vn = xs * ys;

  for (i = 0; i <= xs + 1; ++i)
    for (j = 0; j <= ys + 1; ++j)
      if (i == 0 || i == xs + 1 || j == 0 || j == ys + 1)
        mx[i][j] = 'X';

  for (i = 1; i <= xs; ++i)  {
    for (j = 1; j <= ys; ++j)
      scanf ("%c", &mx[i][j]);
    scanf ("%c", &c);
  }

  for (i = 1; i <= vn; ++i)
    g[i] = o[i] = INF;

  for (i = 1; i <= xs; ++i)
    for (j = 1; j <= ys; ++j)
      fix (i, j);

}

void think ()  {
  int i, j, x, y, t;

  scanf ("%d%d", &x, &y);

  dij1 (num (x,y));

  for (i = 1; i <= as; ++i)  {
    scanf ("%d%d", &x, &y);
    dij2 (num (x,y));
  }

  ans = INT_MIN;

  for (i = 1; i <= vn; ++i)
    if (o[i] > g[i] && ans < o[i])
      ans = o[i];
}

void print ()  {

  int i;
  vex *t;

  for (i = 1; i <= vn; ++i)  {
    printf ("%d", i);
    t = &vx[i];
    while (t -> e != NULL)  {
      printf (" %d", t -> e -> v -> d);
      t = t -> e -> v;
    }
    printf ("\n");
  }

  printf ("%d\n", ans);
}

int main ()  {
  init ();
  think ();
  print ();

  return 0;
}

void hu (int e)  {
  int i, t;

  i = e;
  t = h[e];

  for (;;)  {
    if (i == 1) break;
    if (d[h[i / 2]] <= d[t]) break;
    h[i] = h[i / 2];
    i = i / 2;
  }
  h[i] = t;
}

void hd (int e)  {
  int i, t, m;

  i = e;
  t = h[e];

  for (;;)  {
    if (2 * i > hi) break;
    m = 2 * i;
    if (2 * i + 1 >= hi && d[h[m]] > d[h[m+1]]) ++m;
    if (d[t] <= d[h[m]]) break;
    h[i] = h[m];
    i = m;
  }
  h[i] = t;
}

void hb ()  {
  int i;

  for (i = hi / 2; i >= 1; --i)
    hd (i);
}

int hc ()  {
  int i;

  for (i = hi; i >= 2; --i)
    if (d[h[i]] < d[h[i/2]])
      return 0;

  return 1;
}

void hr (int e)  {
  if (e >= 2 && d[h[e]] < d[h[e/2]]) hu (e);
  else hd (e);
}

