#include <stdio.h>
#include <queue>
using namespace std;

const int inf = 1023456789;

struct Type{
	Type(int _x, int _y){ x = _x, y = _y;}
	Type(){}
	int x,y;
};

struct VType{
	VType(int _x, int _y, int _val){ x = _x, y = _y; val = _val; }
	VType(){}
	int x, y, val;
};

queue<VType> q;

int i, j;
int n, m, k;

int lam[128][128];//lamer
int best[128][128];
int a[128][128];
Type mon[64];
Type per;

void Input(){
	//freopen("chase2.txt", "rt", stdin);
	scanf("%d%d%d", &n, &m, &k);
	char ch;
	scanf("%c", &ch);
	for(i=1; i<=n; i++){
		for(j=1; j<=m; j++){
			scanf("%c", &ch);
			if(ch == 'X')
				a[i][j] = inf;
			else
				a[i][j] = ch - '0';
		}
		scanf("%c", &ch);		
	}
	scanf("%d%d", &per.x, &per.y);
	for(i=1; i<=k; i++)
		scanf("%d%d", &mon[i].x, &mon[i].y);
	return ;
}

inline void Solve(){

	for(i=0; i<=n+1; i++)
		for(j=0; j<=m+1; j++)
			best[i][j] = inf;

	for(int z=1; z<=k; z++)			
		q.push( VType(mon[z].x, mon[z].y, 0) );

	while(!q.empty()){
		VType tmp = q.front();
		q.pop();
		
		if(!(tmp.x >= 1 && tmp.x <= n && tmp.y >= 1 && tmp.y <= m))
			continue;

		if(best[tmp.x][tmp.y] <= tmp.val)
			continue;
	
		best[tmp.x][tmp.y] = tmp.val;
		
	//	printf("*** %d %d <> %d \n", tmp.x, tmp.y, tmp.val);

		i = tmp.x; j = tmp.y;

		if(tmp.x % 2){
					q.push( VType(i-2, j, tmp.val + a[i][j]) );
			q.push( VType(i-1, j-1, tmp.val + a[i][j]) );
			q.push( VType(i-1, j, tmp.val + a[i][j]) );
			
			q.push( VType(i+1, j-1, tmp.val + a[i][j]) );
			q.push( VType(i+1, j, tmp.val + a[i][j]) );
				q.push( VType(i+2, j, tmp.val + a[i][j]) );

		}
		else{
				q.push( VType(i-2, j, tmp.val + a[i][j]) );
			q.push( VType(i-1, j, tmp.val + a[i][j]) );
			q.push( VType(i-1, j+1, tmp.val + a[i][j]) );
			
			q.push( VType(i+1, j, tmp.val + a[i][j]) );
			q.push( VType(i+1, j+1, tmp.val + a[i][j]) );
				q.push( VType(i+2, j, tmp.val + a[i][j]) );
		}
	}
	
	/*
	printf("----best\n");
	for(i=1; i<=n; i++){
		for(j=1; j<=m; j++)
			if(best[i][j] != inf && a[i][j] != inf)
				printf("%3d", best[i][j]);
			else
				printf("  -");
		printf("\n");
	}
	printf("-=-----\n");
	for(i=1; i<=n; i++){
		for(j=1; j<=m; j++)
			if(a[i][j] != inf)
				printf("%3d", a[i][j]);
			else
				printf("  -");
		printf("\n");
	}
	*/
}

inline void LetPLaY(){

	q.push( VType(per.x, per.y, 0) );

	for(i=1; i<=n; i++)
		for(j=1; j<=n; j++)
			lam[i][j] = inf;
	
	while(!q.empty()){

		VType tmp = q.front();
		q.pop();
		
		if(!(tmp.x >= 1 && tmp.x <= n && tmp.y >= 1 && tmp.y <= m))
			continue;

		if(lam[tmp.x][tmp.y] <= tmp.val)
			continue;

		lam[tmp.x][tmp.y] = tmp.val;			

		if(best[tmp.x][tmp.y] <= lam[tmp.x][tmp.y])
			continue;
		
		//printf("* %d %d <> %d \n", tmp.x, tmp.y, tmp.val);

		i = tmp.x; j = tmp.y;

		if(tmp.x % 2){
					q.push( VType(i-2, j, tmp.val + a[i][j]) );
			q.push( VType(i-1, j-1, tmp.val + a[i][j]) );
			q.push( VType(i-1, j, tmp.val + a[i][j]) );
			
			q.push( VType(i+1, j-1, tmp.val + a[i][j]) );
			q.push( VType(i+1, j, tmp.val + a[i][j]) );
				q.push( VType(i+2, j, tmp.val + a[i][j]) );

		}
		else{
				q.push( VType(i-2, j, tmp.val + a[i][j]) );
			q.push( VType(i-1, j, tmp.val + a[i][j]) );
			q.push( VType(i-1, j+1, tmp.val + a[i][j]) );
			
			q.push( VType(i+1, j, tmp.val + a[i][j]) );
			q.push( VType(i+1, j+1, tmp.val + a[i][j]) );
				q.push( VType(i+2, j, tmp.val + a[i][j]) );
		}
	}
	/*
	printf("-=la,er boy-----\n");
	for(i=1; i<=n; i++){
		for(j=1; j<=m; j++)
			printf("%3d", lam[i][j]);
		printf("\n");
	}
	*/
}


int max(int a1, int a2){ return a1 > a2 ? a1 : a2; }

void Output(){
	
	int res = 0;

	for(i=1; i<=n; i++)
		for(j=1; j<=m; j++)
			if(lam[i][j] != inf && a[i][j] != inf)
				res = max(res, best[i][j]);

	printf("%d\n", res);
}

int main(){
	Input();
	Solve();
	LetPLaY();
	Output();
	return 0;
}