#include <stdio.h>
#include <string.h>
#include <queue>

#define MAXN 150
#define MAXK 70
#define INF 0xFFFFFFF
#define VALIDI(a) ((a) >= 0 && (a) < n)
#define VALIDJ(a) ((a) >= 0 && (a) < m)

using namespace std;

int n,m,k;
int grid[MAXN][MAXN];
int si,sj;
int ai[MAXK],aj[MAXK];
int time[MAXK][MAXN][MAXN];
int visited[MAXN][MAXN];
int mintime[MAXN][MAXN];
int max_time = 0;

int moves[2][6][2];

void CompDist(int index,int si,int sj)
{
	int i,j,mini,minj;
	for (i = 0;i < n;i++)
		for (j = 0;j < m;j++)
			time[index][i][j] = INF;
	memset(visited,0,sizeof(visited));
	time[index][si][sj] = 0;
	while (1)
	{
		mini = -1;
		for (i = 0;i < n;i++)
			for (j = 0;j < m;j++)
				if (!visited[i][j] && (mini == -1 || time[index][mini][minj] > time[index][i][j])) 
				{
					mini = i;
					minj = j; 
				}
		if (mini == -1) break;
		visited[mini][minj] = 1;
		for (i = 0;i < 6;i++)
			if (VALIDI(mini + moves[mini%2][i][0]) && VALIDJ(minj + moves[mini%2][i][1]) &&
				time[index][mini + moves[mini%2][i][0]][minj + moves[mini%2][i][1]] > time[index][mini][minj] + grid[mini][minj])
				time[index][mini + moves[mini%2][i][0]][minj + moves[mini%2][i][1]] = time[index][mini][minj] + grid[mini][minj];
	}
}

void Init()
{
	char ch;
	int i,j;
	/* Move 1 */
	moves[0][0][0] = -2;
	moves[0][0][1] = 0;
	moves[1][0][0] = -2;
	moves[1][0][1] = 0;

	/* Move 2 */
	moves[0][1][0] = 2;
	moves[0][1][1] = 0;
	moves[1][1][0] = 2;
	moves[1][1][1] = 0;

	/* Move 3 */
	moves[1][2][0] = -1;
	moves[1][2][1] = 0;
	moves[0][2][0] = -1;
	moves[0][2][1] = -1;

	/* Move 4 */
	moves[1][3][0] = -1;
	moves[1][3][1] = 1;
	moves[0][3][0] = -1;
	moves[0][3][1] = 0;

	/* Move 5 */
	moves[1][4][0] = 1;
	moves[1][4][1] = 1;
	moves[0][4][0] = 1;
	moves[0][4][1] = 0;

	/* Move 6 */
	moves[1][5][0] = 1;
	moves[1][5][1] = 0;
	moves[0][5][0] = 1;
	moves[0][5][1] = -1;

//	freopen("chase.in","rt",stdin);
	scanf("%d%d%d",&n,&m,&k);
	for (i = 0;i < n;i++)
		for (j = 0;j < m;j++)
		{
			scanf("%c",&ch);
			while (!(ch == 'X' || (ch >='1' && ch <= '9')))
				scanf("%c",&ch);
			if (ch == 'X') grid[i][j] = INF;
			else grid[i][j] = ch - '1' + 1;
		}
	scanf("%d%d",&si,&sj);
	si--;sj--;
	for (i = 0;i < k;i++)
	{
		scanf("%d%d",&ai[i],&aj[i]);
		ai[i]--;aj[i]--;
	}
}

void Preprocess()
{
	int i,j,l;
	for (i = 0;i < k;i++)
		CompDist(i,ai[i],aj[i]);
	for (i = 0;i < n;i++)
		for (j = 0;j < m;j++)
		{
			mintime[i][j] = INF;
			for (l = 0;l < k;l++)
				if(mintime[i][j] > time[l][i][j]) mintime[i][j] = time[l][i][j];
		}
}

void Solve()
{
	queue<int> qi;
	queue<int> qj;
	queue<int> qt;
	queue<int> qe;
	int vi,vj,et,time;
	int time_stay;
	int i;
	qi.push(si);
	qj.push(sj);
	qt.push(0);
	qe.push(0);
	while (!qi.empty())
	{
		vi = qi.front();
		vj = qj.front();
		et = qt.front();
		time_stay = qe.front();
		time = et + time_stay;
		qi.pop();qj.pop();qt.pop();qe.pop();
		if (time > max_time) max_time = time;
		if (time >= mintime[vi][vj]) continue;
		qi.push(vi);
		qj.push(vj);
		qt.push(et);
		qe.push(time_stay + 1);
		if (time - et == grid[vi][vj])
		{
			for (i = 0;i < 6;i++)
				if (VALIDI(vi + moves[vi%2][i][0]) && VALIDJ(vj + moves[vi%2][i][1]) && grid[vi + moves[vi%2][i][0]][vj + moves[vi%2][i][1]] < INF)
				{
					qi.push(vi + moves[vi%2][i][0]);
					qj.push(vj + moves[vi%2][i][1]);
					qt.push(time);
					qe.push(0);
				}
		}
	}
}

void Output()
{
	printf("%d\n",max_time);
}

int main()
{
	Init();
	Preprocess();
	Solve();
	Output();
	return 0;
}
