#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define MAXN 100000
#define MAXSUM 1000000


int TIMELIMIT = 0.9*CLOCKS_PER_SEC;
int n,m;
int a[MAXN];
int b[MAXN];
char possa[MAXSUM];
char possb[MAXSUM];

void OutputNo()
{
	printf("0\n");
	exit(0);
}

void Output(int num)
{
	printf("%d\n",num);
	exit(0);
}

int cmp(const void *a,const void *b)
{
	return *((int*)a) - *((int*)b);
}

void Init()
{
	int i;
	//freopen("nubia.in","rt",stdin);
	scanf("%d",&n);
	if (n > MAXN) OutputNo();
	for (i = 0;i < n;i++)
		scanf("%d",&a[i]);

	scanf("%d",&m);
	if (m > MAXN) OutputNo();
	for (i = 0;i < m;i++)
		scanf("%d",&b[i]);

	qsort(a,n,sizeof(a[0]),cmp);
	qsort(b,m,sizeof(b[0]),cmp);
}

void FindSums(int nums[MAXN],int len,char flags[MAXSUM])
{
	char tmp[MAXSUM];
	int i,j;
	for (i = 0;i < len;i++)
	{
		if (clock() > TIMELIMIT) OutputNo();
		memcpy(tmp,flags,sizeof(tmp));
		for (j = MAXSUM - 1;j >= 0 && j - nums[i] >= 0;j--)
			if (!tmp[j] && flags[j - nums[i]]) tmp[j] = 1;
		memcpy(flags,tmp,sizeof(tmp));
	}
}

void Solve()
{
	__int64 suma = 0;
	__int64 sumb = 0;
	__int64 i;
	__int64 last_a;

	/* Preprocess */
	for (i = 0;i < n;i++) suma += a[i];
	for (i = 0;i < m;i++) sumb += b[i];
	if (suma > MAXSUM) OutputNo();
	memset(possa,0,sizeof(possa));
	possa[0] = 1;
	memset(possb,0,sizeof(possa));
	possb[0] = 1;
	FindSums(a,n,possa);
	FindSums(b,n,possb);

	/* Solve phase */
	last_a = suma;
	for (i = suma - 1;i >= 0;i--)
		if (possa[i]) last_a = i;
		else if (!possb[last_a - i]) Output(i);
}

int main()
{
	clock();
	Init();
	Solve();
	OutputNo();
	return 0;
}
