//#define DEBUG

#include <stdio.h>
#include <time.h>

#define IN			"DIV.IN"
#define OUT			"DIV.OUT"
#define MAX			((1<<15)+10)
#define MAX_CACHE	10000000
#define MAX_NUM		1100000

long		n,mas[MAX];
long		next[MAX];
__int64		sum[MAX];
long		res_num,res[MAX];

char		cache[MAX_CACHE];

long		max_time=(0.45)*(double)(CLOCKS_PER_SEC);

long bins(long x)
{
	long l=0,r=n-1,mid;

	while(l<=r)
	{
		mid=(l+r)>>1;
		if(mas[mid]<x) l=mid+1;
		else
			if(mas[mid]>x) r=mid-1;
			else
				return mid;
		
	}
	return next[r];
}

char possible(__int64 num,long last)
{
	long i,end;

	if(num<0)
		return 0;

	if(num==0)
	{
		res_num=0;
		return 1;
	}

	if(num<MAX_CACHE&&cache[num])
		return 0;

	if(num<MAX_NUM)
		end=bins(num);
	else
		end=n-1;

	if(end>last) end=last;

	for(i=end;i>=0&&sum[i]>=num;i--)
		if(possible(num-mas[i], i-1))
		{
			res[res_num++]=mas[i];
			return 1;
		}

	if(num<MAX_CACHE)
		cache[num]=1;

	return 0;
}

long	tmp;
void qsort(long l, long r,long *mas)
{
	long i=l,j=r,mid=mas[(l+r)>>1];

	do
	{
		while(mid>mas[i]) i++;
		while(mid<mas[j]) j--;

		if(i<=j)
		{
			tmp=mas[i];
			mas[i]=mas[j];
			mas[j]=tmp;
			i++;
			j--;
		}
	}while(i<=j);

	if(l<j) qsort(l,j,mas);
	if(i<r) qsort(i,r,mas);
}

void solve()
{
	long i,beg,end;

	qsort(0,n-1,mas);

	sum[0]=mas[0];
	for(i=1;i<n;i++)
		sum[i]=sum[i-1]+mas[i];

	next[n-1]=n-1;
	for(i=n-2;i>=0;i--)
		if(mas[i]==mas[i+1])
			next[i]=next[i+1];
		else
			next[i]=i;

	beg=mas[0]/n;
	if(beg==0) beg=1;
	end=sum[n-1]/(__int64)n;

	res_num=-1;

	if(next[0]==n-1)
	{
		res_num=n;
		for(i=0;i<n;i++)
			res[i]=mas[i];
	}
	else
	{
		for(i=beg;i<=end;i++)
		{
			if( possible( ((__int64)i) * n, n-1) )
				break;
			if(i%1000==0&&clock()>=max_time)
				break;
		}
	}
}

void in()
{
#ifdef DEBUG
	freopen(IN, "r", stdin);
#endif

	scanf("%ld",&n);

	for(long i=0;i<n;i++)
		scanf("%ld",mas+i);

#ifdef DEBUG
	fclose(stdin);
#endif
}

void out()
{
#ifdef DEBUG
	freopen(OUT, "w", stdout);
#endif

	printf("%ld ",res_num);

	if(res_num>0)
	{
		for(long i=0;i<res_num;i++)
			printf("%ld ",res[i]);
		printf("\n");
	}

#ifdef DEBUG
	fclose(stdout);
#endif
}

void main()
{
	in();
	solve();
	out();
}
