/*
TASK:porters
LANG:C++
*/
#include <cstdio>
#include <cstring>
#include <stack>
#include <vector>
#include <queue>
using namespace std;
#define MAXN 1<<18
#define SQRT 300
#define QUERY_COMMAND_NAME "k4i"
#define RAIN_WATER_PER_SEC 10

int N,Root[MAXN],Depth[MAXN],Weight[MAXN],Water[MAXN],Jump[MAXN],F[MAXN],NumberOfTasks;
vector <int> A[MAXN];  

void init();
void calcDepthAndWeight();
void buildJump();
void solveQuery();
void doUpdate();

int main()
{
	//freopen("hamali.in","r",stdin);
	init();
	calcDepthAndWeight();
	buildJump();	
	char command[10];
	for (int i = 1 ; i <= NumberOfTasks ; i++) 
	{ 		
		scanf("%s",command);
		if (!strcmp(command,QUERY_COMMAND_NAME))
			solveQuery();
		else
			doUpdate();
	}
	return 0;
}

void init()
{
	scanf("%d%d",&N,&NumberOfTasks);
	for (int i = 2 ; i <= N ; i++)
	{
		int father;
		scanf("%d",&father);
		Root[i] = father;
		A[father].push_back(i);
	}
}

stack <int> dfs;
int state[MAXN];
void calcDepthAndWeight()
{		
	Depth[1] = 1;
	dfs.push(1);
	while (!dfs.empty())
	{
		const int v = dfs.top();
		if (!state[v])
			Weight[v] = 1;
		if (state[v] == (int)A[v].size())
		{
			dfs.pop();
			Weight[ Root[v] ] += Weight[v];
		}
		else
		{
			const int to = A[v][state[v]];
			Depth[to] = Depth[v] + 1;
			dfs.push(to);
			state[v]++;
		}
	}
}

void buildJump()
{
	memset(state, 0, sizeof state);	
	dfs.push(1);
	while (!dfs.empty()) 
	{
		const int v = dfs.top();
		if (!state[v]) 
		{
			Jump[v] = v == 1 ? 1 : Jump[ Root[v] ];
			do 
			{
				const int jump = Jump[v];
				if (Weight[jump] - Weight[v] <= SQRT)
					break;
				Jump[v] = A[jump][ state[jump] - 1 ];
			}
			while (true);
		}
		if (state[v] == (int)A[v].size())
			dfs.pop();
		else
			dfs.push(A[v][ state[v]++ ]);
	}	
}

void solveQuery()
{
	int time,from,to;
	scanf("%d%d%d",&time,&from,&to);
	int maxPomped = 0,v = from;
	while (Depth[v] > Depth[to])
		if (Depth[Jump[v]] > Depth[to])
		{
			maxPomped = max(maxPomped, F[v]);
			v = Root[ Jump[v] ];
		}
		else
		{
			maxPomped = max(maxPomped, Water[v]);
			v = Root[v];
		}	
	maxPomped = max(maxPomped, Water[to]);
	printf("%d\n",time * RAIN_WATER_PER_SEC - maxPomped);
}

queue <int> bfs;
void doUpdate()
{
	int time,from,volume;
	scanf("%d%d%d",&time,&from,&volume);
	Water[from] += volume;
	bfs.push(from);
	while (!bfs.empty())
	{
		const int v = bfs.front();
		bfs.pop();
		F[v] = max(F[v], Water[from]);
		for (int i = 0 ; i < (int)A[v].size() ; i++)
		{
			const int to = A[v][i];
			if (Depth[ Jump[to] ] <= Depth[from])
				bfs.push(to);
		}
	}
}
