/*
TASK: distance
LANG: C++
*/
#include <iostream>
#define MAXN 24
using namespace std;
struct point { int x; int y; };
point students[MAXN];
int cache[MAXN][MAXN];
int table[MAXN][MAXN];
int n;
int diff(int x1, int x2, int y1, int y2) { return (x1 - y1) * (x1 - y1) + (x2 - y2) * (x2 - y2); }
void create_table(int size)
{
    for (int i = 0; i < size * (size + 1); i++) table[i % (size + 1)][i / (size + 1)] = i % size + 1;
    size++;
    for (int i = 0; i < size; i++)
    {
        table[i][size - 1] = table[size - 1][i] = table[i][i];
        table[i][i] = 0;
    }
}
int solve()
{
    int ret = -1, curr;
    for (int r = 1; r <= n; r++)
    {
        curr = 0;
        for (int i = 0; i < n - 1; i++)
            for (int j = i + 1; j < n; j++)
            {
                if (table[i][j] == r) curr += cache[i+1][j+1];
            }
        ret = max(ret, curr);
    }
    return ret;
}
int main()
{
    cin >> n;
    for (int i = 1; i <= n; i++) cin >> students[i].x >> students[i].y;
    if (n == 2) cout << diff (students[1].x, students[1].y, students[2].x, students[2].y) << ".000" << endl;
    else
    {
        for (int i = 1; i <= n - 1; i++)
            for (int j = i + 1; j <= n; j++)
                cache[i][j] = cache[j][i] = diff(students[i].x, students[i].y, students[j].x, students[j].y);
        create_table(n-1);
        cout << solve() << ".000" << endl;
    }
    return 0;
}
