/*
TASK: distance
LANG: C++
*/

#include <cstdio>
#include <memory.h>
#include <algorithm>
using namespace std;

#define sqr(a) ((a)*(a))

typedef int type;

const int MAX_N = 32;

int n;
int X[MAX_N], Y[MAX_N];

int dist[MAX_N][MAX_N];
unsigned int dp[1<<20];     // !!! MLE   1<<22 !!!
bool V[1<<20];

void input ()
{
	int i, j;

	scanf ("%d", &n);

	for (i=0; i<n; i++)
		scanf ("%d%d", &X[i], &Y[i]);

	for (i=0; i<n; i++)
		for (j=0; j<n; j++)
			dist[i][j] = sqr(X[i]-X[j]) + sqr(Y[i]-Y[j]);

	V[0] = 1;
	dp[0] = 0;
}

unsigned int dfs (int pos)
{
	if (V[pos]) return dp[pos];
	V[pos] = 1;

	int i, j;

	for (i=0; i<n; i++)
		if ((pos>>i)&1)
			for (j=i+1; j<n; j++)
				if ((pos>>j)&1)
					dp[pos] = max( dp[pos], dfs(pos^(1<<i)^(1<<j)) + dist[i][j] );

	return dp[pos];
}

int main ()
{
	//freopen ("distance.in", "r", stdin);

	input ();
	printf ("%u.000\n", dfs((1<<n)-1) );

	return 0;
}