/*
TASK: distance
LANG: C++
*/
#include <iostream>
#include <algorithm>
using namespace std;

long long DP[1<<20];
int N;

struct Point
{
       long long x, y;
} P[22];

long long dist(int a, int b)
{
     return (P[a].x - P[b].x)*(P[a].x - P[b].x) + 
            (P[a].y - P[b].y)*(P[a].y - P[b].y);
}

long long dp(int mask) 
{   
    if (DP[mask] != -1) return DP[mask];
    
    for (int i = 0; i < N-2; i++) if (mask&(1<<i))
     for (int j = i + 1; j < N-2; j++) if (mask&(1<<j))
      DP[mask] = max(DP[mask], dp( ( mask^(1<<i) )^(1<<j)) + dist(i, j));
    
    return DP[mask];
}

int main()
{
    memset(DP, -1, sizeof(DP));
    DP[0] = 0;
    
    cin >> N;
    for (int i = 0; i < N; i++)
     cin >> P[i].x >> P[i].y;
    
    long long res = dp( ( 1<<(N-2) )-1) + dist(N-1, N-2);
    for (int i = N-3; i >= 0; i--)
     for (int j = N-3; j >= 0; j--) if (j != i)
     {
         res = max(res, dp(  ((1<<(N-2))-1 ) ^ (1<<i) ^ (1<<j) )
                               + dist(N-1, i) + dist(N-2, j));
     }
    
    cout << res << ".000" << endl;;
    return 0;
}
