/*
TASK:distance
LANG:C++
*/
#include <iostream>
#include <iomanip>
#define sqr(a)((a)*(a))
using namespace std;

struct point{short x, y;}stud[22];
struct gr
{
    short i,j;
    double f;
    bool operator<(const gr& a) const
    { return (*this).f > a.f; }
}graph[500];
int m(0);
int N;
void kruskal();
int prev[500];
bool incl[500];
bool used[22];
double maxsum = 0.0;
int getRoot(int);
int cntInh(int);
void clrArcs(int);

int main()
{
    cin >> N;
    int i, j;
    for (i=0;i < N;i++)
     cin >> stud[i].x >> stud[i].y;
    
    while (1)
    {
          m = 0;
          for (i=0;i < N;i++)
           for (j=i+1;j < N;j++)
            if (!used[i] && !used[j])
            {
               graph[m].i = i;
               graph[m].j = j;
               graph[m].f = sqr(stud[i].x - stud[j].x) + sqr(stud[i].y - stud[j].y);
               m++;
            }
            
            //kruskal();
            memset(incl, 1, sizeof(incl));
            sort(graph, graph + m);
            // mahame malki rebra svurzani s vurhove s pove4e ot 1 rebro
            /*for (i=m-1; i >= 0;i--)
             if (incl[i])
              if (cntInh(graph[i].i) > 1 && cntInh(graph[i].j) > 1)
               incl[i] = false;
            */
            // mahame vsi4ki ostanali
            for (i=0;i < N;i++)
             if (!used[i])
              clrArcs(i);
            
            // koeto ostane zapazvame i used[] = 1
            for (i=0;i < m;i++)
             if (incl[i])
              {
                 maxsum += graph[i].f;
                 used[graph[i].i] = true;
                 used[graph[i].j] = true;
                 //cout << graph[i].i << " " << graph[i].j << endl;
              }
             //cout << endl << endl; 
            // i spirame ako sa vkliu4eni vsi4ki vurhove
            for (i=0; i < N;i++)
             if (!used[i]) break;
            if (i == N) break;   
    }
    
    cout << setiosflags(ios::fixed) << setprecision(3) << maxsum << endl;
    //system("pause");
    return 0;
}
     
void kruskal()
{
     memset(prev, -1, sizeof(prev));
     memset(incl, 1, sizeof(incl));
     sort(graph, graph + m);
     
     for (int i=0;i < m;i++)
     {
         int r1 = getRoot(graph[i].i);
         int r2 = getRoot(graph[i].j);
         if (r1 != r2) prev[r2] = r1;
         else incl[i] = 0;
     }
}

int getRoot(int i)
{
    int root = i;
    while (prev[root] != -1) root = prev[root];
    
    while (i != root)
    {
        int savei = i;
        i = prev[i];
        prev[savei] = root;
    }
    return root;
}

int cntInh(int x)
{
    int cnt = 0;
    for (int i=0; i < m;i++)
     if (incl[i])
      if (graph[i].i == x || graph[i].j == x)
       cnt++;
    
    return cnt;
}
    
void clrArcs(int x) //vertex x
{
     double maxf = 0;
     int maxi;     
     
     for (int i=0;i < m;i++)
      if (incl[i])
       if (graph[i].i == x || graph[i].j == x)
        if (graph[i].f > maxf)
        {
           maxf = graph[i].f;
           maxi = i;
        }
     for (int i=0;i < m;i++)
      if (incl[i])
       if (graph[i].i == x || graph[i].j == x)
        if (i != maxi)
         incl[i] = false;
}
