/*
TASK: string
LANG: C++
*/
#include <cstdio>
#include <algorithm>

const int MAX_N = 1 << 20;

int N, ans[MAX_N], F[MAX_N];
char s[MAX_N];

int length(int start, int end)
{
int cur, ret = 1;
	
	F[0] = - 1;
	F[1] = 0;
	cur = F[1];
	
	for(int i = 1; i <= end - start; i ++)
	{
		while(0 <= cur && s[start + cur] != s[start + i])
		{
			if(s[start + i] < s[start + cur])
			{
				return ret;
			}
			
			ret = i + 1;
			
			if(0 < cur) cur = F[cur - 1];
			else cur = F[cur];
		}
		
		F[i] = ++ cur;
	}
	
	return ret;
}

void Read()
{
	scanf("%s", s);
}

void Solve()
{
	int start = 0, end = strlen(s) - 1;
	
	while(start <= end)
	{
		int temp = length(start, end);
		
		ans[N ++] = temp;
		
		start += temp;
	}
}

void Write()
{
	printf("%d", N);
	
	for(int i = 0; i < N; i ++)
		printf(" %d", ans[i]);
	
	printf("\n");
}

int main()
{
	Read();
	
	Solve();
	
	Write();
	
	return 0;
}
