/*
TASK: table
LANG: C++
*/
#include <cstdio>
#include <algorithm>
using namespace std;

int dx[] = { -1 , 0 , 0 , 1 };
int dy[] = { 0 , -1 , 1 , 0 };

const int MAXN = 35;
const int mod = 333333;

int n , m;
int t[MAXN][MAXN];
int num[MAXN][MAXN];
int p[MAXN * MAXN][MAXN * MAXN];
int c;

void read() {
	int i , j;
	
	scanf ( "%d%d" , &n , &m );
	
	for (i = 1; i <= n; i++)
		for (j = 1; j <= m; j++)
			scanf ( "%d" , &t[i][j] );
}

int inv ( int x ) {
	if ( x == 0 ) return 0;
	if ( x == 1 ) return 2;
	if ( x == 2 ) return 1;
	return -(1 << 30);
}

void solve() {
	int i , j , k;
	int pos;
	int eq;
	int ans = 1;
	
	for (i = 1; i <= n; i++)
		for (j = 1; j <= m; j++)
			num[i][j] = ++c;
	
	for (i = 1; i <= n; i++)
		for (j = 1; j <= m; j++) {
			for (k = 0; k < 4; k++)
				if ( num[ i + dx[k] ][ j + dy[k] ] )
					p[ num[i][j] ][ num[ i + dx[k] ][ j + dy[k] ] ] = 1;
			
			p[ num[i][j] ][c + 1] = t[i][j];
		}
				
	for (k = 1; k <= c; k++) {
		pos = 0;
		
		for (i = k; i <= c; i++)
			if ( p[i][k] ) {
				pos = i;
				break;
			}
		
		if ( !pos ) continue;
		for (j = 1; j <= c + 1; j++)
			swap ( p[k][j] , p[ pos ][j] );
		
		for (i = k + 1; i <= c; i++) 
			if ( p[i][k] ) {
				eq = (p[k][k] == p[i][k]);
				
				for (j = 1; j <= c + 1; j++) {
					if ( eq )
						p[i][j] = (inv (p[k][j]) + p[i][j]) % 3;
					else
						p[i][j] = (p[k][j] + p[i][j]) % 3;
				}
			}
	}
	
	for (i = 1; i <= c; i++) {
		for (j = 1; j <= c; j++)
			if ( p[i][j] ) break;
		
		if ( j == c + 1 ) {
			if ( p[i][j] ) ans = 0;
			else ans = (ans * 3) % mod; 
		}
	}
	
	printf ( "%d\n" , ans );
}

int main() {
	read();
	solve();

	return 0;
}
