/*
TASK:table
LANG:C++
*/
#include <cstdio>
#include <algorithm>

using namespace std;

const int MAXN = 1<<5;
const int MOD = 333333;

int m, n;
int s[MAXN+2][MAXN+2], t[MAXN+2][MAXN+2];
int ans=0;

void init (void) {
     scanf("%d%d", &m, &n);
     if (m<=n) {
        for (int i=0; i<=m+1; ++i) s[i][0]=s[i][n+1]=0;
        for (int j=0; j<=n+1; ++j) s[0][j]=s[m+1][j]=0;
        for (int i=1; i<=m; ++i)
            for (int j=1; j<=n; ++j) {
                scanf("%d", &t[i][j]);
                s[i][j]=-1;
                }
        } else {
               for (int i=0; i<=n+1; ++i) s[i][0]=s[i][m+1]=0;
               for (int j=0; j<=m+1; ++j) s[0][j]=s[n+1][j]=0;
               for (int i=1; i<=m; ++i)
                   for (int j=1; j<=n; ++j) {
                       scanf("%d", &t[j][i]);
                       s[j][i]=-1;
                       }
               swap(m,n);
               }
     }

void print (void) {
     for (int i=0; i<=m+1; ++i) {
         for (int j=0; j<=n+1; ++j)
             printf("%d ", s[i][j]);
         printf("\n");
         }
     printf("\n");
     }

void solve0 (int x, int y) {
     if (x>m) {
              for (int j=1; j<=n; ++j)
                  if (t[x-1][j]!=((s[x-2][j]+s[x-1][j-1]+s[x-1][j+1])%3)) return;
              //print();
              ++ans;
              if (ans>MOD) ans-=MOD;
              return;
              }
     if (y>n) { solve0(x+1,1); return; }
     if (x==1) {
        s[x][y]=0; solve0(x,y+1);
        s[x][y]=1; solve0(x,y+1);
        s[x][y]=2; solve0(x,y+1);
        } else {
               s[x][y]=t[x-1][y]+27;
               s[x][y]-=s[x-2][y];
               s[x][y]-=s[x-1][y-1];
               s[x][y]-=s[x-1][y+1];
               s[x][y]%=3;
               solve0(x,y+1);
               }
     }

int comp (int x, int y) {
    int i;
    for (i=1; i<y && x+i<=m; ++i) {
        s[x+i][y-i]=t[x+i-1][y-i]+27;
        s[x+i][y-i]-=s[x+i-2][y-i];
        s[x+i][y-i]-=s[x+i-1][y-i-1];
        s[x+i][y-i]-=s[x+i-1][y-i+1];
        s[x+i][y-i]%=3;
        //printf("%d %d %d\n", x+i, y-i, s[x+i][y-i]);
        }
    return --i;
    }

void solve1 (int x, int y) {
     if (x>m) {
              if (t[x-1][n-1]!=((s[x-2][n-1]+s[x][n-1]+s[x-1][n-2]+s[x-1][n])%3)) return;
              if (t[x-1][n]!=((s[x-2][n]+s[x][n]+s[x-1][n-1]+s[x-1][n+1])%3)) return;
              ++ans;
              if (ans>MOD) ans-=MOD;
              //printf("!\n"); return;
              }
     if (y>n) {
              solve1(x+1,n);
              //printf(".\n");
              return;
              }
     if (x==1) {
        s[x][y]=0;
        //printf("%d %d %d\n", x, y, s[x][y]);
        int i=comp(x,y);
        if (y-i>1) {
           if (t[x+i][y-i-1]==((s[x+i-1][y-i-1]+s[x+i+1][y-i-1]+s[x+i][y-i-2]+s[x+i][y-i])%3))
              {
              //printf("%d ? %d %d %d %d\n", t[x+i][y-i-1], s[x+i-1][y-i-1], s[x+i+1][y-i-1], s[x+i][y-i-2], s[x+i][y-i]);
              //printf("i=%d .%d %d %d\n", i, x, y+1, s[x][y+1]);
              solve1(x,y+1);
              }
           } else {
                  //printf(".%d %d %d\n", x, y+1, s[x][y+1]);
                  solve1(x,y+1);
                  }
        s[x][y]=1;
        //printf("%d %d %d\n", x, y, s[x][y]);
        i=comp(x,y);                                                                                      
        if (y-i>1) {
           if (t[x+i][y-i-1]==((s[x+i-1][y-i-1]+s[x+i+1][y-i-1]+s[x+i][y-i-2]+s[x+i][y-i])%3))
              {
              //printf("%d ? %d %d %d %d\n", t[x+i][y-i-1], s[x+i-1][y-i-1], s[x+i+1][y-i-1], s[x+i][y-i-2], s[x+i][y-i]);
              //printf("i=%d .%d %d %d\n", i, x, y+1, s[x][y+1]);
              solve1(x,y+1);
              }
           } else {
                  //printf(".%d %d %d\n", x, y+1, s[x][y+1]);
                  solve1(x,y+1);
                  }
        s[x][y]=2;
        //printf("%d %d %d\n", x, y, s[x][y]);
        i=comp(x,y);                                                                                      
        if (y-i>1) {
           if (t[x+i][y-i-1]==((s[x+i-1][y-i-1]+s[x+i+1][y-i-1]+s[x+i][y-i-2]+s[x+i][y-i])%3))
              {
              //printf("%d ? %d %d %d %d\n", t[x+i][y-i-1], s[x+i-1][y-i-1], s[x+i+1][y-i-1], s[x+i][y-i-2], s[x+i][y-i]);
              //printf("i=%d .%d %d %d\n", i, x, y+1, s[x][y+1]);
              solve1(x,y+1);
              }
           } else {
                  //printf(".%d %d %d\n", x, y+1, s[x][y+1]);
                  solve1(x,y+1);
                  }
        }
        else {
             s[x][y]=t[x-1][y]+27;
             s[x][y]-=s[x-2][y];
             s[x][y]-=s[x-1][y-1];
             s[x][y]-=s[x-1][y+1];
             s[x][y]%=3;
             //printf("%d %d %d\n", x, y, s[x][y]);
             int i=comp(x,y);                                                                   
             if (t[x+i][y-i-1]!=((s[x+i-1][y-i-1]+s[x+i+1][y-i-1]+s[x+i][y-i-2]+s[x+i][y-i])%3)) return;
             //printf(".%d %d %d\n", x, y+1, s[x][y+1]);
             solve1(x,y+1);
             }
     }

void solve (void) {
     //print();
     //solve0(1,1);
     solve1(1,1);
     }

int main()
{
    init();
    solve();
    printf("%d\n", ans);
    
return 0;
}
