/*
TASK: string
LANG: C++
*/
#include <stdio.h>
#include <string>
using namespace std;

char S[1000002];
bool DP[1000][1000];
int N;

struct interval
{
       int i, j;
       interval(int _i, int _j):i(_i), j(_j){}
       interval(){}
} stack[1000000];

int smalleroreq(int i1, int j1, int i2, int j2)
{
     for (int k = 0; i1 + k <= j1 && i2 + k <= j2; k++)
      if (S[i1+k] > S[i2+k]) return 0;
      else if (S[i1+k] < S[i2+k]) return 1;
     return j1 - i1 <= j2 - i2;
}

bool smaller(int i1, int j1, int i2, int j2)
{
     for (int k = 0; i1 + k <= j1 && i2 + k <= j2; k++)
      if (S[i1+k] > S[i2+k]) return 0;
      else if (S[i1+k] < S[i2+k]) return 1;
     return j1 - i1 < j2 - i2;
}

bool simple(int i, int j)
{
     for (int k = j; k > i; k--) if (smaller(k, j, i, j)) return 0;
     return 1;
}

void print(int i, int j)
{
     for (int k = i; k <= j; k++) printf("%c", S[k]);
     printf("\n");
}

int cnt;
int path[1000000];

void generate(int previ, int prevj)
{
     if (previ < 1000 && prevj < 1000)
     {
               if (DP[previ][prevj]) return;
               DP[previ][prevj] = 1;
     }
     //printf("%d %d\n", previ, prevj);
     if (prevj == N-1)
     {
               printf("%d", cnt);
               for (int i = 0; i < cnt; i++) printf(" %d", path[i]);
               printf("\n");
               exit(0);
     }
     int i = prevj+1;
     for (int j = prevj + 1; j < N; j++)
      if (simple(i, j) && 
          (previ == -1 || smalleroreq(i, j, previ, prevj)))
      {
            path[cnt++] = j - i + 1;
            generate(i, j);
            --cnt;
      }
}
int main()
{
    scanf("%s", S);
    N = strlen(S);
    //for (int i = 0; i < N; i++)
    // for (int j = i; j < N; j++) if (simple(i, j)) print(i, j);
    //if (N < 1000) generate(-1, -1);
    generate(-1, -1);
    /*int c = -1;
    for (int i = 0; i < N; i++)
    {
        stack[++c] = interval(i, i);
        while (c > 0 && smaller(stack[c-1].i, stack[c-1].j, stack[c].i, stack[c].j))
        {
              --c;
              stack[c].j = stack[c+1].j;
        }
    }
    printf("%d", c+1);
    for (int i = 0; i <= c; i++) printf(" %d", stack[i].j - stack[i].i + 1); 
    */
    return 0;
}
