//Autor: Savin Tiberiu
//Complexitate: O(N+M*H)

#include <stdio.h>
#include <vector>

using namespace std;

#define NMAX 100002
#define DEBUG false

vector< pair<int, pair<int, int> > > G[NMAX];
pair<int, pair<int, int> > TT[NMAX];
int dpth[NMAX];
int viz[NMAX];
int N, M;

void DF(int nod, int dp) {
  viz[nod] = 1;
  dpth[nod] = dp;
  for (int i = 0; i < (int)G[nod].size(); i++) {
    if (viz[G[nod][i].first]) {
      continue;
    }
    int x, y, d, v;
    x = nod;
    y = G[nod][i].first;
    d = G[nod][i].second.first;
    v = G[nod][i].second.second;
    TT[y] = make_pair(x, make_pair(d, v));
    DF(y, dp + 1);
  }
}

double move_up(int &y, int v) {
  int crt_v, dist;
  crt_v = min<int>(TT[y].second.second, v);
  dist = TT[y].second.first;
  if (DEBUG) {
    fprintf(stderr, "%d to %d with time %.3f (distance = %d speed = %d)\n",
              y, TT[y].first, 1.0 * dist / crt_v, dist, crt_v);
  }
  y = TT[y].first;
  return (crt_v != 0) ? (1.0 * (double)dist / (double)crt_v) : 0;
}

int main() {
  freopen("trenuri.in", "r", stdin);
  freopen("trenuri.out", "w", stdout);

  scanf("%d %d ", &N, &M);

  for (int i = 1; i < N; i++) {
    int x, y, d, v;
    scanf("%d %d %d %d ", &x, &y, &d, &v);
    G[x].push_back(make_pair(y, make_pair(d, v)));
    G[y].push_back(make_pair(x, make_pair(d, v)));
  }

  DF(1, 0);
  for (int i = 1; i <= M; i++) {
    int x, y, v;
    scanf("%d %d %d ", &x, &y, &v);

    double ret = 0;
    if (DEBUG) {
      fprintf(stderr, "Query: %d %d %d\n", x, y, v);
    }

    while (dpth[y] > dpth[x]) {
      ret = ret + move_up(y, v);
    }

    while (dpth[y] < dpth[x]) {
      ret = ret + move_up(x, v);
    }

    while (x != y) {
      ret = ret + move_up(x, v);
      ret = ret + move_up(y, v);
    }

    printf("%.3f\n", ret);
  }

  return 0;
}
