//Autor: Gheorghe Cosmin
//Complexitate: O(N + M * log M + M * log N)

#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;

#define NMAX 100010
#define LGMAX 20

#define MP make_pair
#define ff first
#define ss second

int N, M, lgmax;

vector <pair<int, pair<int, int> > > leg[NMAX];

char viz[NMAX];
int nod[NMAX];
int poz[NMAX];
int nfii[NMAX];
int niv[NMAX];

int tata[LGMAX][NMAX];

int nmm;
pair <pair<int, int>, pair<int, int> > mm[NMAX];
pair <pair<int, int>, pair<int, int> > qq[NMAX];

double aint_mari[NMAX << 2];
double aint_mici[NMAX << 2];

double rezf[NMAX];

void back(int x)
{
	viz[x] = 1;
	nod[++nod[0]] = x;
	poz[x] = nod[0];
	nfii[x] = 1;

	for (vector <pair<int, pair<int, int> > > :: iterator it = leg[x].begin(); it != leg[x].end(); ++it) {
		int y = it->ff;
		if (viz[y]) continue;

		tata[0][y] = x;
		niv[y] = niv[x] + 1;
		back(y);

		nfii[x] += nfii[y];
		mm[++nmm] = MP( MP(it->ss.ss, it->ss.ff), MP(x, y) );
	}
}

void update(double aint[], int x, int y, int q, int a, int b, double val)
{
	if (a <= x && y <= b) {
		aint[q] += val;
		return;
	}

	int mij = (x + y) >> 1;

	if (a <= mij) update(aint, x, mij, q << 1, a, b, val);
	if (b > mij) update(aint, mij + 1, y, (q << 1) + 1, a, b, val);
}

double query(double aint[], int x, int y, int q, int poz, double s)
{
	s += aint[q];

	if (x == y) return s;

	int mij = (x + y) >> 1;

	if (poz <= mij) return query(aint, x, mij, q << 1, poz, s);
	return query(aint, mij + 1, y, (q << 1) + 1, poz, s);
}

int lca(int x, int y)
{
	int k;

	for (k = lgmax; k >= 0 && niv[x] >= niv[y]; k--)
		if (niv[tata[k][x]] >= niv[y])
			x = tata[k][x];

	for (k = lgmax; k >= 0 && niv[y] >= niv[x]; k--)
		if (niv[tata[k][y]] >= niv[x])
			y = tata[k][y];

	if (x == y) return x;

	for (k = lgmax; k >= 0; k--)
		if (tata[k][x] != tata[k][y]) {
			x = tata[k][x];
			y = tata[k][y];
		}
	
	return tata[0][x];

}

int main()
{
	int i, x, y, d, v, k;

	freopen("trenuri.in", "r", stdin);
	freopen("trenuri.out", "w", stdout);

	scanf("%d %d", &N, &M);

	for (i = 1; i < N; i++) {
		scanf("%d %d %d %d", &x, &y, &d, &v);

		leg[x].push_back(MP(y, MP(d, v)));
		leg[y].push_back(MP(x, MP(d, v)));
	}

	tata[0][1] = 1;
	back(1);

//	for (i = 1; i <= N; i++) printf("%d ", nod[i]);
//	printf("\n");

	for (k = 1; (1 << (k-1)) <= N; k++)
		for (i = 1; i <= N; i++)
			tata[k][i] = tata[k-1][tata[k-1][i]];
	lgmax = k - 1;

	sort(mm + 1, mm + nmm + 1);
	
	for (i = 1; i <= nmm; i++) {
		int y = mm[i].ss.ss;

//		printf("%d %d\n", poz[y], poz[y] + nfii[y] - 1);

		update(aint_mari, 1, N, 1, poz[y], poz[y] + nfii[y] - 1, mm[i].ff.ss);
	}

//	printf("%g\n", query(aint_mari,1, N, 1, 1, 0));

//	return 0;

	for (i = 1; i <= M; i++) {
		scanf("%d %d %d", &x, &y, &v);

		qq[i] = MP(MP(v, i), MP(x, y));
	}

	sort(qq + 1, qq + M + 1);

	int j = 1;

	for (i = 1; i <= M; i++) {
		x = qq[i].ss.ff;
		y = qq[i].ss.ss;
		v = qq[i].ff.ff;

		while (j <= nmm && mm[j].ff.ff <= v) {
			int y = mm[j].ss.ss;
			update(aint_mari, 1, N, 1, poz[y], poz[y] + nfii[y] - 1, -mm[j].ff.ss);

			update(aint_mici, 1, N, 1, poz[y], poz[y] + nfii[y] - 1, (double) mm[j].ff.ss / mm[j].ff.ff);
			j++;
		}

		int lc = lca(x, y);

//		printf("%d %d - %d\n", x, y, lc);

		double rez = query(aint_mici, 1, N, 1, poz[x], 0) + query(aint_mici, 1, N, 1, poz[y], 0) - 2 * query(aint_mici, 1, N, 1, poz[lc], 0);
		double rez1 = query(aint_mari, 1, N, 1, poz[x], 0) + query(aint_mari, 1, N, 1, poz[y], 0) - 2 * query(aint_mari, 1, N, 1, poz[lc], 0);

		rezf[qq[i].ff.ss] = rez + rez1 / v;
	}

	for (i = 1; i <= M; i++) printf("%0.3lf\n", rezf[i]);

	return 0;
}

