/*
 * Author: Andrei Grigorean
 * Time complexity O(N! * N^2)
 */

#include <cassert>
#include <cstdio>
#include <cstring>

#include <algorithm>
using namespace std;

const int MAX_N = 301;

int n, m;
long long k;
int v[MAX_N], u[MAX_N];

void read() {
    assert(freopen("bubblesort.in", "r", stdin) != NULL);
    assert(freopen("bubblesort.out", "w", stdout) != NULL);

    assert(scanf("%d %d %lld", &n, &m, &k) == 3);
}

int getOrder() {
    memcpy(u, v, sizeof(v));
    int steps = 0;
    while (true) {
        ++steps;
        bool isSorted = true;
        for (int i = 0; i + 1 < n; ++i)
            if (u[i] > u[i + 1]) {
                swap(u[i], u[i + 1]);
                isSorted = false;
            }
        if (isSorted) break;
    }
    return steps;
}

void solve() {
    for (int i = 0; i < n; ++i)
        v[i] = i + 1;
    do {
        int order = getOrder();
        if (order == m && --k == 0) {
            for (int i = 0; i < n; ++i)
                printf("%d%s", v[i], i == n - 1 ? "\n" : " ");
            return;
        }
    } while (next_permutation(v, v + n));
}

int main() {
    read();
    solve();
}
