/*
 * Author: Cosmin Gheorghe
 * Time complexity: O(N^3)
 */

#include <stdio.h>

#define NMAX 100010

#define LL long long

int N;

int xx[NMAX], yy[NMAX];

LL arie(int x, int y, int x1, int y1, int x2, int y2)
{
	LL rez = (LL) x * (y1 - y2) - (LL) y * (x1 - x2) + (LL) x1 * y2 - (LL) y1 * x2;

	if (rez < 0) rez = -rez;

	return rez;
}

int main()
{
	int i, j, k;

	freopen("hawaii.in", "r", stdin);
	freopen("hawaii.out", "w", stdout);

	scanf("%d", &N); N++;

	for (i = 1; i <= N; i++) {
		scanf("%d %d", &xx[i], &yy[i]);
	}

	LL rez = 0;
	for (i = 2; i <= N; i++)
		for (j = i + 1; j <= N; j++)
			for (k = j + 1; k <= N; k++) {
				LL ar1 = arie(xx[1], yy[1], xx[i], yy[i], xx[j], yy[j]);
				LL ar2 = arie(xx[1], yy[1], xx[i], yy[i], xx[k], yy[k]);
				LL ar3 = arie(xx[1], yy[1], xx[k], yy[k], xx[j], yy[j]);

				LL art = arie(xx[i], yy[i], xx[j], yy[j], xx[k], yy[k]);

				if (ar1 + ar2 + ar3 == art) {
					//printf("%d %d %d\n", i - 1, j - 1, k - 1);
					rez++;
				}
			}

	printf("%lld\n", rez);

	return 0;
}

