/*
 * Author: Andrei Grigorean
 * Expected score: 100
 */

#include <cassert>
#include <cstdio>

#include <map>
#include <vector>
using namespace std;

const int MAX_N = 1000005;
const int MAX_M = 512;
const int MAX_L = 2505;
const int BASE = 37;
const int MOD = 666013;

int n, m, l, k;
char s[MAX_N];
map< int, vector<int> > hash;
char word[MAX_L];

int dist(char *a, char *b, int n) {
    int sol = 0;
    for (int i = 0; i < n; ++i)
        sol += a[i] != b[i];
    return sol;
}

void buildHash(int len) {
    int hashVal = 0;
    for (int i = 0; i + 1 < len && i < n; ++i)
        hashVal = (hashVal * BASE + (s[i] - 'a')) % MOD;

    int coef = 1;
    for (int i = 1; i < len; ++i)
        coef = coef * BASE % MOD;

    for (int i = len - 1; i < n; ++i) {
        hashVal = (hashVal * BASE + (s[i] - 'a')) % MOD;
        hash[hashVal].push_back(i - len + 1);

        hashVal = (hashVal - coef * (s[i - len + 1] - 'a')) % MOD;
        if (hashVal < 0) hashVal += MOD;
    }
}

int findMatch(int pos) {
    if (pos < 0 || pos + l > n) return 0;
    return dist(s + pos, word, l) <= k;
}

int main() {
    assert(freopen("radio.in", "r", stdin) != NULL);
    assert(freopen("radio.out", "w", stdout) != NULL);

    assert(scanf("%d %d %d %d", &n, &m, &l, &k) == 4);
    assert(scanf("%s", s) == 1);

    int len = l / (k + 1);
    buildHash(len);

    for (int i = 0; i < m; ++i) {
        assert(scanf("%s", word) == 1);

        int found = 0;
        for (int i = 0; i + len <= l; i += len) {
            int hashVal = 0;
            for (int j = 0; j < len; ++j)
                hashVal = (hashVal * BASE + (word[i + j] - 'a')) % MOD;

            if (hash.find(hashVal) != hash.end())
                for (vector<int>::iterator it = hash[hashVal].begin(); it != hash[hashVal].end(); ++it)
                    found |= findMatch(*it - i);
        }
        printf("%d\n", found);
    }
}
