/*
	Airinei Adrian
	Complexitate O(N*logN)
*/
#include <cstdio>
#include <cstring>
#include <vector>
using namespace std;

#define MAXN 100100
#define MAXARB (1<<18)
#define left (nod << 1)
#define right ((nod << 1) | 1)
#define mid ((st+dr) >> 1)

int N, M, viz[MAXN], L[MAXN], R[MAXN], K[MAXN], list[MAXN], P[MAXN];
int query[MAXN], dist[MAXN], dfntime;
vector<int> Ans[MAXN], G[MAXN], C[MAXN], SOL[MAXN];
int Poz[MAXARB], arb[MAXARB], Max[MAXARB];

inline int max(int a, int b) { return a > b ? a : b; }

void fill(int nod, int st, int dr)
{
	if(st == dr) { Poz[nod] = st; return ; }
	fill(left, st, mid), fill(right, mid+1, dr);
}


void update(int nod, int st, int dr, int a, int b, int val)
{
	if(a > b) return ;
	if(a <= st && dr <= b)
	{
		arb[nod] += val; Max[nod] += val;
		return ;
	}
	if(a <= mid) update(left, st, mid, a, b, val);
	if(b > mid) update(right, mid+1, dr, a, b, val);
	if(Max[right] >= Max[left])
		Max[nod] = Max[right]+arb[nod], Poz[nod] = Poz[right];
	else
		Max[nod] = Max[left]+arb[nod], Poz[nod] = Poz[left];
}

void dfs_time(int x)
{
	int i;
	viz[x] = 1, L[x] = R[x] = ++dfntime, P[dfntime] = x;
	for(i = 0; i < G[x].size(); i++)
		if(!viz[G[x][i]])
		{
			dist[G[x][i]] = dist[x] + C[x][i];
			dfs_time(G[x][i]);
			R[x] = max(R[x], R[G[x][i]]);
		}
}

void dfs(int x)
{
	int i;
	viz[x] = 1;
	for(i = 1; i <= K[x]; i++)
	{
		Ans[x].push_back(P[Poz[1]]);
		SOL[x].push_back(Max[1]);
		list[i] = Max[1];
		update(1, 1, N, Poz[1], Poz[1], -Max[1]);
	}
	for(i = 1; i <= K[x]; i++)
		update(1, 1, N, L[Ans[x][i-1]], L[Ans[x][i-1]], list[i]);
	for(i = 0; i < G[x].size(); i++)
	{
		int y = G[x][i];
		int c = C[x][i];
		if(!viz[y])
		{
			update(1, 1, N, 1, L[y]-1, c);
			update(1, 1, N, R[y]+1, N, c);
			update(1, 1, N, L[y], R[y], -c);
			dfs(y);
			update(1, 1, N, 1, L[y]-1, -c);
			update(1, 1, N, R[y]+1, N, -c);
			update(1, 1, N, L[y], R[y], c);
		}
	}
}

void read_and_solve(void)
{
	int i, j, k, c;
	scanf("%d %d\n", &N, &M);
	for(i = 1; i < N; i++)
		scanf("%d %d %d\n", &j, &k, &c),
		G[j].push_back(k), G[k].push_back(j), C[j].push_back(c), C[k].push_back(c);
	for(i = 1; i <= M; i++)
		scanf("%d\n", &query[i]), K[query[i]]++;
	dfs_time(1);
	memset(viz, 0, sizeof(viz));
	fill(1, 1, N);
	for(i = 1; i <= N; i++)
		update(1, 1, N, i, i, dist[P[i]]);
	dfs(1);
	memset(list, 0, sizeof(list));
	for(i = 1; i <= M; i++)
		printf("%d\n", SOL[query[i]][ list[query[i]]++ ]);
}

int main(void)
{
	freopen("regat.in", "rt", stdin);
	freopen("regat.out", "wt", stdout);

	read_and_solve();

	return 0;
}




	


			



